
dofile("Base.rte/Constants.lua")
require("Actors/AI/NativeCrabAI")

function Create(self)
	self.AI = NativeCrabAI:Create(self)
	self.addelem = true;
	self.charged = false;
	self.casting = false;
	self.elemtable = {}; --start from 0
	self.elemtable[1] = 0;  --0:none
	self.elemtable[2] = 0;  --1:fire
	self.elemtable[3] = 0;  --10:fel
	self.elemnumber = 0; --number of active elems
	self.elemmax = 3; --max number of active elems
	self.spell = -1; --sum elem to get
	
	self.targetDist = 1200;
	self.judgeDist = 0;
	self.target = nil;
	self.spelltarget = Vector(0,0);
	self.prevspelltarget = Vector(0,0);
	self.Prev = Vector(self.Pos.X, self.Pos.Y);
	if ToActor(self):NumberValueExists("Summon") == false then
		ToActor(self):SetNumberValue("Summon", 0);
	end
	--[[
	local pylon = 0;
	for tester in MovableMan.Actors do
		if ToActor(tester):NumberValueExists("Summon") then
			if tester.Team == self.Team then
				pylon = pylon - ToActor(tester):GetNumberValue("Summon");
			end
		end
	end
	--print(pylon);
	if pylon < 0 then
		self.Health = -4444;
		self.Sharpness = 4;
	end]]
	self.delayTimer = Timer();
	--KILL MAGE IF UNLOADED FROM CARFT SECOND TIME(MAGICAL INTERACTION W TECH ON FIELD W O WARDING)
	if self.Sharpness == 1 then
		self.Sharpness = 0;
	else
		self.Health = -4444;
		self.Sharpness = 4;
		--self:GibThis();
	end
end

function Update(self)
	--print(self.elemnumber);
	if self.EquippedItem ~= nil then
		self.EquippedItem.Frame = 2;
	end
	if self.elemnumber < self.elemmax then
		if self:IsPlayerControlled() then
			if self:GetController():IsState(Controller.HOLD_UP) and self.EquippedItem ~= nil then
				if self.addelem then
					self.elemnumber = self.elemnumber + 1;
					self.elemtable[self.elemnumber] = 1; --fire
				end
				self.addelem = false;
			elseif self:GetController():IsState(Controller.HOLD_DOWN) then
				if self.addelem then
					self.elemnumber = self.elemnumber + 1;
					self.elemtable[self.elemnumber] = 10; --fel
				end
				self.addelem = false;
			else
				self.addelem = true;
			end
		else
			if self.EquippedItem == nil then
				self.elemnumber = 3;
				self.elemtable[1] = 10; --fel
				self.elemtable[2] = 10; --fel
				self.elemtable[3] = 10; --fel
				self:GetController():SetState(Controller.PRIMARY_ACTION, true);
			elseif self:NumberValueExists("Barrier") ~= true then
				self.elemnumber = 3;
				self.elemtable[1] = 10; --fel
				self.elemtable[2] = 10; --fel
				self.elemtable[3] = 0; --void
				self:GetController():SetState(Controller.PRIMARY_ACTION, true);
			elseif self.Health < 20 and not (self.EquippedItem ~= nil and ToHDFirearm(self.EquippedItem):IsActivated()) then
				self.elemnumber = 3;
				self.elemtable[1] = 10; --fel
				self.elemtable[2] = 0; --void
				self.elemtable[3] = 0; --void
				self:GetController():SetState(Controller.PRIMARY_ACTION, true);
			elseif (self.EquippedItem ~= nil and ToHDFirearm(self.EquippedItem):IsActivated()) then
				--print("P")
				local VectorRel = Vector(1200,0):RadRotate(self:GetAimAngle(true));--:GetXFlipped(self.HFlipped))
				ray = SceneMan:CastObstacleRay(self.EquippedItem.Pos, VectorRel, self.spelltarget, self.prevspelltarget, self.RootID, self.Team, 0, 1);
				if ray >= 0 then
					--FrameMan:DrawLinePrimitive(self.Pos, self.spelltarget, 0);
					if self.Health <= 30 and math.random(1,15) == 1 then --water nova
						self.elemnumber = 3;
						self.elemtable[1] = 0; --void
						self.elemtable[2] = 1; --fire
						self.elemtable[3] = 10; --fel
					elseif ray <= 80 and math.random(1,2) == 1 then --inferno
						self.elemnumber = 3;
						self.elemtable[1] = 1; --fire
						self.elemtable[2] = 0; --void
						self.elemtable[3] = 0; --void
					elseif ray <= 160 and math.random(1,2) == 1 then --Zephyr Draft
						self.elemnumber = 3;
						self.elemtable[1] = 0; --void
						self.elemtable[2] = 0; --void
						self.elemtable[3] = 0; --void
					elseif ray <= 320 and math.random(1,2) == 1 then --Acid Spew
						self.elemnumber = 3;
						self.elemtable[1] = 1; --fire
						self.elemtable[2] = 1; --fire
						self.elemtable[3] = 10; --fel
					elseif ray <= 640 and math.random(1,2) == 1 then --Blaze Ray
						self.elemnumber = 3;
						self.elemtable[1] = 1; --fire
						self.elemtable[2] = 1; --fire
						self.elemtable[3] = 1; --fire
					elseif self.Health <= 30 and math.random(1,2) == 1 then --Fire Flash
						self.elemnumber = 3;
						self.elemtable[1] = 1; --fire
						self.elemtable[2] = 1; --fire
						self.elemtable[3] = 0; --void
					else --Blood Spines
						self.elemnumber = 3;
						self.elemtable[1] = 10; --fel
						self.elemtable[2] = 10; --fel
						self.elemtable[3] = 1; --fire
					end
				end
			end
		end			
	end
	if self.elemnumber > 0 then
		--local vec = SceneMan:ShortestDistance(self.Prev, self.Pos, true);
		--if vec.Magnitude < 50 then
		--	self.Pos.X = self.Pos.X + (vec.X * 0.15 * self.elemnumber);
		--	self.Pos.Y = self.Pos.Y + (vec.Y * 0.15 * self.elemnumber);
		--end
		if self.EquippedItem ~= nil then
			self.EquippedItem.Frame = 1;
		end
		for i = 1, self.elemnumber do
			FrameMan:DrawCircleFillPrimitive(self.Pos + Vector(-10-self.elemnumber*10+i*20,-30), 7, 245);
			local name = "Emblem AirBase Glow";
			if self.elemtable[i] == 1 then
				name = "Emblem Armageddon Glow";
			elseif self.elemtable[i] == 10 then
				name = "Emblem FoN Glow";
			end
			local emblem = CreateMOSParticle(name, "AAA.rte");
			--local emblem = CreateMOSParticle(EmblemGet(self.spelltable[i]));
			emblem.Pos = self.Pos + Vector(-10-self.elemnumber*10+i*20,-30);
			emblem.Vel = self.Vel;
			--emblem.Vel = Vector(0,0);
			MovableMan:AddParticle(emblem);
		end
	end
	if self:GetController():IsState(Controller.PRIMARY_ACTION) or (self.EquippedItem ~= nil and ToHDFirearm(self.EquippedItem):IsActivated()) then
		if self.EquippedItem ~= nil then
			self.EquippedItem.Frame = 2;
		end
		if self.casting == false then
			self.delayTimer:Reset();
			self.spell = self.elemtable[1] + self.elemtable[2] + self.elemtable[3];
			self.elemtable[1] = 0;  --0:none
			self.elemtable[2] = 0;  --1:fire
			self.elemtable[3] = 0;  --2:fel
			self.elemnumber = 0; --number of active elems
			self.casting = true;
			self.charged = false;
		end
		if self.spell == 0 then
			if self.charged == false and self.EquippedItem ~= nil and self.delayTimer:IsPastSimMS(1000) then
				local explosion = CreateMOSRotating("Particle Summon Explosion", "AAA.rte");
				explosion.Pos = self.Pos;
				explosion.Vel = Vector(0,0);
				MovableMan:AddParticle(explosion);
				explosion:GibThis();
				self.charged = true;
				if not self:IsPlayerControlled() then
					ToHDFirearm(self.EquippedItem):Deactivate()
				end
			end
		elseif self.spell == 10 then
			if self.delayTimer:IsPastSimMS(400) then
				local flicker = CreateAEmitter("AAA.rte/Flyblood");
				if flicker then
					flicker.Pos = self.Pos + Vector(math.random(40,100),0):RadRotate(math.random() * 2 * math.pi);
					flicker.Sharpness = self.ID;
					MovableMan:AddParticle(flicker);
				end
				self.delayTimer:Reset();
				if not self:IsPlayerControlled() and self.Health > 50 then
					self.charged = true;
					ToHDFirearm(self.EquippedItem):Deactivate()
				end
			end
		elseif self.spell == 20 then
			if self.charged == false then
				local Effect = CreateAEmitter("FelBarrier", "AAA.rte");
				Effect.Pos = self.Pos;
				--Effect:SetWhichMOToNotHit(actor, 0.1)
				Effect.Team = self.Team;
				Effect.Sharpness = self.RootID;
				Effect.IgnoresTeamHits = true;
				--Add the particle to the world.
				MovableMan:AddParticle(Effect);
				self.charged = true;
			end
		elseif self.spell == 30 then
			if self.charged == false then
				self.Health = math.ceil((self.Health-1)*0.5);
				--local Effect = CreateACRocket("Fly Glyph", "AAA.rte");
				local Effect = CreateACrab("Fly Heart", "AAA.rte");
				Effect.Pos = self.Pos + Vector(0,-6);
				--Effect:SetWhichMOToNotHit(actor, 0.1)
				Effect.Team = self.Team;
				Effect.IgnoresTeamHits = true;
				Effect.Health = self.Health;
				--Add the particle to the world.
				MovableMan:AddActor(Effect);
				if self:IsPlayerControlled() then
					ActivityMan:GetActivity():SwitchToActor(ToActor(Effect),ToActor(self):GetController().Player,self.Team);
				end
				--local item = CreateAHuman("Dummy");
				--Effect:AddInventoryItem(item);
				self.charged = true;
				ActivityMan:GetActivity():ReportDeath(self.Team,-1);
				self.Sharpness = 4;
				self:GibThis();
			end
		elseif self.spell == 1 and self.EquippedItem ~= nil then --flame breath
			if self.delayTimer:IsPastSimMS(30) then
				local missile = CreateMOSParticle("Fire Puff Large Long", "AAA.rte");
				missile.Team = self.Team;
				missile.IgnoresTeamHits = true;
				missile.Pos = self.EquippedItem.Pos; --actor.EquippedItem.Pos;
				missile.Vel = self.Vel + Vector(25,0):RadRotate(self:GetAimAngle(true) + 0.1 - math.random() / 5);
				MovableMan:AddParticle(missile);
				local missile = CreateMOSParticle("Fire Puff Large Hurtful", "AAA.rte");
				missile.Team = self.Team;
				missile.IgnoresTeamHits = true;
				missile.Pos = self.EquippedItem.Pos; --actor.EquippedItem.Pos;
				missile.Vel = self.Vel + Vector(25,0):RadRotate(self:GetAimAngle(true) + 0.1 - math.random() / 5);
				MovableMan:AddParticle(missile);
				self.delayTimer:Reset();
				if not self:IsPlayerControlled() and math.random(1,12) == 12 then
					self.charged = true;
					ToHDFirearm(self.EquippedItem):Deactivate()
				end
			end
		elseif self.spell == 2 and self.EquippedItem ~= nil then --fireball
			if self.charged == false and self.delayTimer:IsPastSimMS(2000) then
				local explosion = CreateMOSRotating("Particle Summon Explosion", "AAA.rte");
				explosion.Pos = self.Pos;
				explosion.Vel = Vector(0,0);
				MovableMan:AddParticle(explosion);
				explosion:GibThis();
				self.charged = true;
				if not self:IsPlayerControlled() then
					ToHDFirearm(self.EquippedItem):Deactivate()
				end
			end
		elseif self.spell == 3 and self.EquippedItem ~= nil then --fireray
			if self.charged == false then
				local PlayedSound = CreateAEmitter("FireballCast Sound Emitter");
				PlayedSound.Pos = self.EquippedItem.Pos;
				MovableMan:AddParticle(PlayedSound);
				local Effect = CreateAEmitter("Firelaser", "AAA.rte");
				Effect.Pos = self.EquippedItem.Pos;
				--Effect:SetWhichMOToNotHit(actor, 0.1)
				Effect.Team = self.Team;
				Effect.Sharpness = self.RootID;
				Effect.IgnoresTeamHits = true;
				--Add the particle to the world.
				MovableMan:AddParticle(Effect);
				self.charged = true;
			end
		elseif self.spell == 12 and self.EquippedItem ~= nil then
			if self.charged == false and self.delayTimer:IsPastSimMS(500) then
				local explosion = CreateMOSRotating("Particle Summon Explosion", "AAA.rte");
				explosion.Pos = self.Pos;
				explosion.Vel = Vector(0,0);
				MovableMan:AddParticle(explosion);
				explosion:GibThis();
				self.charged = true;
				if not self:IsPlayerControlled() then
					ToHDFirearm(self.EquippedItem):Deactivate()
				end
			end
		elseif self.spell == 21 and self.EquippedItem ~= nil then
			if self.charged == false and self.delayTimer:IsPastSimMS(1500) then
				local explosion = CreateMOSRotating("Particle Summon Explosion", "AAA.rte");
				explosion.Pos = self.Pos;
				explosion.Vel = Vector(0,0);
				MovableMan:AddParticle(explosion);
				explosion:GibThis();
				self.charged = true;
				if not self:IsPlayerControlled() then
					ToHDFirearm(self.EquippedItem):Deactivate()
				end
			end
		elseif self.spell == 11 then --water nova
			if self.charged == false then
				for i = 1, 48 do
					--[[
					local missile = CreateMOSRotating("Acid Spit", "AAA.rte");
					missile.Team = self.Team;
					missile.IgnoresTeamHits = true;
					missile.Pos = self.Pos; --actor.EquippedItem.Pos;
					missile.Vel = self.Vel + Vector(55,0):DegRotate(i*1);
					MovableMan:AddParticle(missile);
					]]
					local missile = CreateMOPixel("Water Jet", "AAA.rte");
					missile.Team = self.Team;
					missile.IgnoresTeamHits = true;
					missile.Pos = self.Pos; --actor.EquippedItem.Pos;
					missile.Vel = self.Vel + Vector(85,0):DegRotate(math.random()*360);
					MovableMan:AddParticle(missile);
				end
				self.charged = true;
			end
		end
	else
		if self.casting then
			local power = self.delayTimer.ElapsedSimTimeMS;
			if self.spell == 0 and self.EquippedItem ~= nil then --air blast
				local PlayedSound = CreateAEmitter("Push Sound Emitter");
				PlayedSound.Pos = self.Pos;
				MovableMan:AddParticle(PlayedSound);
				for i = 1, math.min(math.floor(1+64*power/1000),65) do
					Effect = CreateMOPixel("Air Blast", "Base.rte");
					if Effect then
						Effect.Vel = Vector(35 + math.random() * 20,0):RadRotate(self:GetAimAngle(true) + 0.25 - math.random() / 2);
						if actor ~= nil then
							Effect.Vel = Effect.Vel + self.Vel;
						end
						Effect.Pos = self.EquippedItem.Pos;
						Effect.Team = self.Team;
						Effect.IgnoresTeamHits = true;
						MovableMan:AddParticle(Effect);
					end
				end
			elseif self.spell == 2 and self.EquippedItem ~= nil then --fireball
				local missile = CreateAEmitter("Fireball", "AAA.rte");
				missile.Team = self.Team;
				missile.IgnoresTeamHits = true;
				missile.Pos = self.EquippedItem.Pos; --actor.EquippedItem.Pos;
				missile.Vel = self.Vel + Vector(55 * math.min((power/2000),1) + math.random() * 5,0):RadRotate(self:GetAimAngle(true) + 0.05 - math.random() / 10);
				MovableMan:AddParticle(missile);
			elseif self.spell == 12 and self.EquippedItem ~= nil then --acid shotgun
				for i = 1, math.min(math.floor(3+17*power/500),8) do
					local missile = CreateMOSRotating("Acid Spit", "AAA.rte");
					missile.Team = self.Team;
					missile.IgnoresTeamHits = true;
					missile.Pos = self.EquippedItem.Pos; --actor.EquippedItem.Pos;
					missile.Vel = self.Vel + Vector(55 * math.min(power/500,1) + math.random() * 15,0):RadRotate(self:GetAimAngle(true) + (0.5+0.5*math.min((power/500),1))*(0.25 - math.random() / 2));
					MovableMan:AddParticle(missile);
				end
			elseif self.spell == 21 and self.EquippedItem ~= nil then --blood spike
				for i = 1, math.min(math.floor(1+2*power/1500),3) do
					local missile = CreateAEmitter("Blood Bolt", "AAA.rte");
					missile.Team = self.Team;
					missile.IgnoresTeamHits = true;
					missile.Pos = self.EquippedItem.Pos; --actor.EquippedItem.Pos;
					missile.Vel = self.Vel + Vector(130 * math.min(power/1500,1),0):RadRotate(self:GetAimAngle(true) + (1.0-0.98*math.min((power/1500),1))*(0.25 - math.random() / 2));
					MovableMan:AddParticle(missile);
				end
			end
			--elseif self.spell == 11 then
			self.spell = 0;
			self.delayTimer:Reset();
			self.charged = false;
			self.casting = false;
		end
		
	end
	if not self:IsPlayerControlled() then
		if self.casting and self.charged then
			local power = self.delayTimer.ElapsedSimTimeMS;
			if self.spell == 0 and self.EquippedItem ~= nil then --air blast
				local PlayedSound = CreateAEmitter("Push Sound Emitter");
				PlayedSound.Pos = self.Pos;
				MovableMan:AddParticle(PlayedSound);
				for i = 1, math.min(math.floor(1+64*power/1000),65) do
					Effect = CreateMOPixel("Air Blast", "Base.rte");
					if Effect then
						Effect.Vel = Vector(35 + math.random() * 20,0):RadRotate(self:GetAimAngle(true) + 0.25 - math.random() / 2);
						if actor ~= nil then
							Effect.Vel = Effect.Vel + self.Vel;
						end
						Effect.Pos = self.EquippedItem.Pos;
						--Effect:SetWhichMOToNotHit(self, 0.1);
						--Effect.LifeTime = math.random(1000,1250);
						Effect.Team = self.Team;
						Effect.IgnoresTeamHits = true;
						MovableMan:AddParticle(Effect);
					end
				end
			elseif self.spell == 2 and self.EquippedItem ~= nil then --fireball
				local missile = CreateAEmitter("Fireball", "AAA.rte");
				missile.Team = self.Team;
				missile.IgnoresTeamHits = true;
				missile.Pos = self.EquippedItem.Pos; --actor.EquippedItem.Pos;
				missile.Vel = self.Vel + Vector(55 * math.min((power/2000),1) + math.random() * 5,0):RadRotate(self:GetAimAngle(true) + 0.05 - math.random() / 10);
				MovableMan:AddParticle(missile);
			elseif self.spell == 12 and self.EquippedItem ~= nil then --acid shotgun
				for i = 1, math.min(math.floor(3+17*power/500),8) do
					local missile = CreateMOSRotating("Acid Spit", "AAA.rte");
					missile.Team = self.Team;
					missile.IgnoresTeamHits = true;
					missile.Pos = self.EquippedItem.Pos; --actor.EquippedItem.Pos;
					missile.Vel = self.Vel + Vector(55 * math.min(power/500,1) + math.random() * 15,0):RadRotate(self:GetAimAngle(true) + (0.5+0.5*math.min((power/500),1))*(0.25 - math.random() / 2));
					MovableMan:AddParticle(missile);
				end
			elseif self.spell == 21 and self.EquippedItem ~= nil then --blood spike
				for i = 1, math.min(math.floor(1+2*power/1500),3) do
					local missile = CreateAEmitter("Blood Bolt", "AAA.rte");
					missile.Team = self.Team;
					missile.IgnoresTeamHits = true;
					missile.Pos = self.EquippedItem.Pos; --actor.EquippedItem.Pos;
					missile.Vel = self.Vel + Vector(130 * math.min(power/1500,1),0):RadRotate(self:GetAimAngle(true) + (1.0-0.98*math.min((power/1500),1))*(0.25 - math.random() / 2));
					MovableMan:AddParticle(missile);
				end
			end
			self.spell = 0;
			self.delayTimer:Reset();
			self.charged = false;
			self.casting = false;
			ToHDFirearm(self.EquippedItem):Deactivate()
		end
	end
	self.Prev = self.Pos;
	self.RotAngle = 0; --prevent tipping
end

function UpdateAI(self)
	self.AI:Update(self)
end

function Destroy(self)
	if self.Sharpness ~= 4 then
		local explosion = CreateMOSRotating("Particle Large Spell Explosion", "AAA.rte");
		explosion.Pos = self.Pos;
		explosion.Vel = Vector(0,0);
		MovableMan:AddParticle(explosion);
		explosion:GibThis();
	end
end
