function Create(self)

	self.gotid = self.Sharpness;
	self.bind = false;
	if IsActor(MovableMan:GetMOFromID(self.gotid)) then
		self.owner = ToActor(MovableMan:GetMOFromID(self.gotid));
		if IsActor(self.owner) then
			if ToActor(self.owner):NumberValueExists("Star") ~= true then
				ToActor(self.owner):SetNumberValue("Star",self.UniqueID);
				self.bind = true;
			else
				--ToActor(self.owner):RemoveNumberValue("Star");
				--self:GibThis();
				ToActor(self.owner):SetNumberValue("Star",self.UniqueID);
				self.bind = true;
			end
		else
			self.owner = nil;
		end
	else
		self.owner = nil;
	end
	self.Sharpness = 0;
	self.AngularVel = (math.random() - 0.5) * 0.05
	self.Ammo = 14;
	self.targetDist = 900;
	self.frostTimer = Timer();
end


function Update(self)
	--print("STAR");
	--print(ToActor(self.owner):GetNumberValue("Star"));
	--print(self.ID);
	--FrameMan:ShowPerformanceStats(true);
	--local radius = self.Scale * 29.0;
	--FrameMan:DrawLinePrimitive(self.Pos, self.Pos + Vector(radius, 0):RadRotate(self.RotAngle), 0)
	--FrameMan:DrawLinePrimitive(self.Pos, self.Pos + Vector(radius, 0):RadRotate(self.RotAngle + math.pi * 0.5), 1)
	--FrameMan:DrawLinePrimitive(self.Pos, self.Pos + Vector(radius, 0):RadRotate(self.RotAngle + math.pi * 1.0), 1)
	--FrameMan:DrawLinePrimitive(self.Pos, self.Pos + Vector(radius, 0):RadRotate(self.RotAngle + math.pi * 1.5), 1)
	
	if not MovableMan:IsActor(self.target) or self.target.Team == self.Team then
		--Find a target.
		for actor in MovableMan.Actors do
			if actor.Team ~= self.Team then
				if SceneMan:ShortestDistance(self.Pos, actor.Pos, true).Magnitude < self.targetDist then
					if not SceneMan:CastStrengthRay(self.Pos, SceneMan:ShortestDistance(self.Pos, actor.Pos, true), 15, Vector(), 5, 0, true) then
						self.target = actor;
					end
				end
			end
		end
	end
	if MovableMan:IsActor(self.target) then
		--FrameMan:DrawLinePrimitive(self.Pos, self.target.Pos, 0)
		local vec = SceneMan:ShortestDistance(self.Pos, self.target.Pos, true);
		if SceneMan:CastStrengthRay(self.Pos, vec, 15, Vector(), 5, 0, true) then
			self.target = nil;
			--print("ray nil");
		else
			local particle = CreateMOPixel("Homing Bone","AAA.rte");
			particle.Pos = self.Pos;
			particle.Vel = self.Vel;
			--self.particle.Vel = Vector(math.random(-25,25)+self.Vel.X*0.3,math.random(-25,25)+self.Vel.Y*0.3)
			particle.Team = self.Team;
			particle.IgnoresTeamHits = true;
			particle.Sharpness = self.target.ID;
			MovableMan:AddParticle(particle);
			
			self.ToDelete = true;
		--[[
			if self.Ammo > 0 then
				if vec.X > 0 then
					self.AngularVel = self.AngularVel + 0.001;
				else
					self.AngularVel = self.AngularVel - 0.001;
				end
				if math.abs(self.AngularVel) > 0.2 then
					--print("firing");
					if self.frostTimer:IsPastSimMS(50) then
						self.frostTimer:Reset();
						
						local missile = CreateMOSRotating("Blizzard Shard", "AAA.rte");
						missile.Team = self.Team;
						missile.IgnoresTeamHits = true;
						missile.Pos = self.Pos;
						missile.Vel = Vector(60 + math.random() * 10, 0):RadRotate(vec.AbsRadAngle + 0.05 - math.random() / 10);
						--missile.Vel = Vector(70, 0):RadRotate(vec.AbsRadAngle);
						missile.Vel.Y = missile.Vel.Y - 0.5 * (SceneMan.GlobalAcc.Y * TimerMan.DeltaTimeSecs) * (vec.X/missile.Vel.Magnitude);
						MovableMan:AddParticle(missile);
						self.Ammo = self.Ammo - 1;
						self.Scale = self.Scale - 0.006;
					end
					
				end
			else
				self.target = nil;
				
			end
			]]
		end
	else
        self.target = nil;
		--print("actor nil");
	end
	
end

function Destroy(self)

end