function Create(self)

	self.gotid = self.Sharpness;
	self.bind = false;
	if IsActor(MovableMan:GetMOFromID(self.gotid)) then
		self.owner = ToActor(MovableMan:GetMOFromID(self.gotid));
		if IsActor(self.owner) then
			if ToActor(self.owner):NumberValueExists("Burning") ~= true then
				ToActor(self.owner):SetNumberValue("Burning",self.UniqueID);
				self.bind = true;
			else
				--self:GibThis();
				ToActor(self.owner):SetNumberValue("Burning",self.UniqueID);
				self.bind = true;
			end
		else
			self.owner = nil;
		end
	else
		self.owner = nil;
	end
	self.Sharpness = 0;
	self.burnTimer = Timer();
end


function Update(self)

	if IsActor(self.owner) then
		if ToActor(self.owner):GetNumberValue("Burning") ~= self.UniqueID then
			self:GibThis();
		end
		if self.burnTimer:IsPastSimMS(100) then
			local num = math.random(1,2);
			local explosion = CreateMOSParticle("Flame " .. num .. " Hurt");
			if explosion then
				explosion.Pos = self.Pos + Vector(math.random(-3,3),math.random(-3,3));
				explosion.Vel = Vector(0,0);
				MovableMan:AddParticle(explosion);
			end
			for actor in MovableMan.Actors do
			if IsAHuman(actor) or IsACrab(actor) then
				if ToActor(actor):GetNumberValue("Burning") ~= self.UniqueID then
					if SceneMan:ShortestDistance(self.Pos, actor.Pos, true).Magnitude < 20 then
						local Effect = CreateAEmitter("BurningCount", "AAA.rte");
						Effect.Pos = actor.Pos;
						--Effect:SetWhichMOToNotHit(actor, 0.1)
						Effect.Team = self.Team;
						Effect.Sharpness = actor.RootID;
						Effect.IgnoresTeamHits = true;
						--Add the particle to the world.
						MovableMan:AddParticle(Effect);
					end
				end
			end
		end
			self.burnTimer:Reset();
		end
		self.Pos = self.owner.Pos;
	else
		self:GibThis();
	end

end

function Destroy(self)
	
	if IsActor(self.owner) and self.bind == true then
		if ToActor(self.owner):NumberValueExists("Burning") == true then
			if ToActor(self.owner):GetNumberValue("Burning") == self.UniqueID then
				ToActor(self.owner):RemoveNumberValue("Burning");
			end
		end
	end

end