function Create(self)

	self.alliedTeam = -1;
	self.regenTimer = Timer();

end

function Update(self)

	if self.ID ~= self.RootID then
		local actor = MovableMan:GetMOFromID(self.RootID);
		if MovableMan:IsActor(actor) then
			if self.alliedTeam == -1 then
				self.alliedTeam = ToActor(actor).Team;
				if ToActor(actor):NumberValueExists("Summon") then
					ToActor(actor):SetNumberValue("Summon", ToActor(actor):GetNumberValue("Summon") - 6);
				end
			end
			if self.regenTimer:IsPastSimMS(1000) then
				self.regenTimer:Reset();
				if ToActor(actor):NumberValueExists("Bonus Mana") then
					ToActor(actor):SetNumberValue("Bonus Mana", ToActor(actor):GetNumberValue("Bonus Mana") + 8);
				end
				if self.WoundCount > 16 then
					if ToAHuman(actor).Head ~= nil then
						ToAHuman(actor).Head:Detach();
					end
				elseif self.WoundCount > 4 then
					self:RemoveWounds(1);
					ToActor(actor).Health = ToActor(actor).Health - 3;
				end
			end
		end
	else
		if self.PresetName ~= "Necronomicon" then
			self.PresetName = "Necronomicon";
		end
		if self.SharpLength ~= 0 then
			self.SharpLength = 0;
		end
		if self.alliedTeam ~= -1 then
			local explosion = CreateMOSRotating("Particle Summon Explosion", "AAA.rte");
			explosion.Pos = self.Pos + Vector(0,-6);
			explosion.Vel = Vector(0,0);
			MovableMan:AddParticle(explosion);
			explosion:GibThis();
			for i = -12, 12, 4 do
				local explosion = CreateAEmitter("Necron Bolt", "AAA.rte");
				explosion.Pos = self.Pos;
				explosion.Vel = Vector(i,-8);
				MovableMan:AddParticle(explosion);
				ToAEmitter(explosion):SetNumberValue("Team", self.alliedTeam);
				if i == 0 then
					ToAEmitter(explosion):SetStringValue("Name", "Skeleton Sapper");
				elseif i == 8 or i == -8 then
					ToAEmitter(explosion):SetStringValue("Name", "Skeleton Soldier");
				else
					ToAEmitter(explosion):SetStringValue("Name", "Skeleton Scout");
				end
				local missile = CreateAEmitter("Magic Missile Missile", "AAA.rte");
				missile.Team = self.alliedTeam;
				missile.IgnoresTeamHits = true;
				missile.Pos = self.Pos;
				missile.Vel = Vector(i,-8);
				MovableMan:AddParticle(missile);
			end
			self:GibThis();
		end
	end

end

function Destroy(self)

end