function Create(self)
	self.stepx = self.Vel.X;
	self.stepy = self.Vel.Y;
	--self.Vel.X = 0;
	--self.Vel.Y = 0;

	self.lifeTimer = Timer();
	self.emitTimer = Timer();

end

function Update(self)
	if self.Vel.Magnitude < 20 then
		self.Vel = self.Vel * 1.1;
	end
	if self.emitTimer:IsPastSimMS(6) then
		for i = 1, 25 do
			local damagePar = CreateMOPixel("Particle Heavy Digger", "Base.rte");
			damagePar.Pos = self.Pos;
			damagePar.Vel = Vector((math.random()*40)+20,0):RadRotate(math.pi*2*math.random());
			damagePar.Team = self.Team;
			damagePar.IgnoresTeamHits = true;
			MovableMan:AddParticle(damagePar);
			local damagePar = CreateMOPixel("Particle Very Heavy Digger", "Base.rte");
			damagePar.Pos = self.Pos;
			damagePar.Vel = Vector((math.random()*40)+20,0):RadRotate(math.pi*2*math.random());
			damagePar.Team = self.Team;
			damagePar.IgnoresTeamHits = true;
			MovableMan:AddParticle(damagePar);
		end
		self.emitTimer:Reset();
	end

	if self.lifeTimer:IsPastSimMS(3800) then
		self:GibThis();
	end

end