function Create(self)

	self.burstTimer = Timer();
	self.actionPhase = 0;
	self.alliedTeam = -1;

end

function Update(self)

	--print(self.overallTimer.ElapsedSimTimeMS)
	--print(self.delayTimer.ElapsedSimTimeMS)
	if self.ID ~= self.RootID then
		local actor = MovableMan:GetMOFromID(self.RootID);
		if MovableMan:IsActor(actor) then
			self.alliedTeam = ToActor(actor).Team;
		end
	end

	if self.actionPhase == 0 then
		if self:IsActivated() then
			--self.Magazine.RoundCount = 500-self.overallTimer.ElapsedSimTimeMS;
			--if self.delayTimer:IsPastSimMS(500) then
				self.actionPhase = 1;
				self.Magazine.RoundCount = 200;
				--self.blink = false;
				--local soundfx = CreateAEmitter("Digger Sound Activate");
				--soundfx.Pos = self.Pos;
				--MovableMan:AddParticle(soundfx);
			--end
		else
			self.Magazine.RoundCount = 200;
			self.actionPhase = 0;
		end
	elseif self.actionPhase >= 1 then
		--actionPhase = 1 + tonumber(self.delayTimer:IsPastSimMS(1000)) + tonumber(self.delayTimer:IsPastSimMS(2000))
		
		if self.burstTimer:IsPastSimMS(150) then
			for i = 1, 3 do
				Effect = CreateMOPixel("Bullet Sulphurous Flare", "AAA.rte")
				if Effect then
					Effect.Vel = self.Vel + self:RotateOffset(Vector(90 + math.random() * 10,0)):DegRotate(-25 + math.random()*50)--self:RotateOffset(Vector(90 + math.random() * 10,0):RadRotate(self.RotAngle):DegRotate(-25 + math.random()*50))
					Effect.Pos = self.Pos;
					Effect:SetWhichMOToNotHit(self, 0.1);
					Effect.Team = self.alliedTeam;
					Effect.IgnoresTeamHits = true;
					MovableMan:AddParticle(Effect);
				end
			end
			self.burstTimer:Reset();
			self.Magazine.RoundCount = self.Magazine.RoundCount - 1;
		end

		if self.Magazine.RoundCount <= 0 then
			self:GibThis();
		end
	end

end