function StarGib(self)
	local radius = self.Scale * 29.0;
	local explosion = CreateMOSRotating("Large Ice Gib", "AAA.rte");
	explosion.Pos = self.Pos + Vector(radius, 0):RadRotate(self.RotAngle);
	explosion.Vel = Vector(10, 0):RadRotate(self.RotAngle);
	explosion.RotAngle = self.RotAngle;
	explosion.Scale = self.Scale;
	MovableMan:AddParticle(explosion);
	
	local explosion = CreateMOSRotating("Large Ice Gib", "AAA.rte");
	explosion.Pos = self.Pos + Vector(radius, 0):RadRotate(self.RotAngle + math.pi * 0.5);
	explosion.Vel = Vector(10, 0):RadRotate(self.RotAngle + math.pi * 0.5);
	explosion.RotAngle = self.RotAngle + math.pi * 0.5;
	explosion.Scale = self.Scale;
	MovableMan:AddParticle(explosion);
	
	local explosion = CreateMOSRotating("Large Ice Gib", "AAA.rte");
	explosion.Pos = self.Pos + Vector(radius, 0):RadRotate(self.RotAngle + math.pi * 1.0);
	explosion.Vel = Vector(10, 0):RadRotate(self.RotAngle + math.pi * 1.0);
	explosion.RotAngle = self.RotAngle + math.pi * 1.0;
	explosion.Scale = self.Scale;
	MovableMan:AddParticle(explosion);
	
	local explosion = CreateMOSRotating("Large Ice Gib", "AAA.rte");
	explosion.Pos = self.Pos + Vector(radius, 0):RadRotate(self.RotAngle + math.pi * 1.5);
	explosion.Vel = Vector(10, 0):RadRotate(self.RotAngle + math.pi * 1.5);
	explosion.RotAngle = self.RotAngle + math.pi * 1.5;
	explosion.Scale = self.Scale;
	MovableMan:AddParticle(explosion);
end

function Create(self)

	self.gotid = self.Sharpness;
	self.bind = false;
	if IsActor(MovableMan:GetMOFromID(self.gotid)) then
		self.owner = ToActor(MovableMan:GetMOFromID(self.gotid));
		if IsActor(self.owner) then
			if ToActor(self.owner):NumberValueExists("Star") ~= true then
				ToActor(self.owner):SetNumberValue("Star",self.UniqueID);
				self.bind = true;
			else
				--ToActor(self.owner):RemoveNumberValue("Star");
				--self:GibThis();
				ToActor(self.owner):SetNumberValue("Star",self.UniqueID);
				self.bind = true;
			end
		else
			self.owner = nil;
		end
	else
		self.owner = nil;
	end
	self.Sharpness = 0;
	self.AngularVel = (math.random() - 0.5) * 0.05
	self.Ammo = 14;
	self.targetDist = 900;
	self.frostTimer = Timer();
	self.target = nil;
end


function Update(self)
	--print("STAR");
	--print(ToActor(self.owner):GetNumberValue("Star"));
	--print(self.ID);
	--FrameMan:ShowPerformanceStats(true);
	--local radius = self.Scale * 29.0;
	--FrameMan:DrawLinePrimitive(self.Pos, self.Pos + Vector(radius, 0):RadRotate(self.RotAngle), 0)
	--FrameMan:DrawLinePrimitive(self.Pos, self.Pos + Vector(radius, 0):RadRotate(self.RotAngle + math.pi * 0.5), 1)
	--FrameMan:DrawLinePrimitive(self.Pos, self.Pos + Vector(radius, 0):RadRotate(self.RotAngle + math.pi * 1.0), 1)
	--FrameMan:DrawLinePrimitive(self.Pos, self.Pos + Vector(radius, 0):RadRotate(self.RotAngle + math.pi * 1.5), 1)
	
	if not MovableMan:IsActor(self.target) or self.target.Team == self.Team then
		--Find a target.
		for actor in MovableMan.Actors do
			if actor.Team ~= self.Team then
				if SceneMan:ShortestDistance(self.Pos, actor.Pos, true).Magnitude < self.targetDist then
					if not SceneMan:CastStrengthRay(self.Pos, SceneMan:ShortestDistance(self.Pos, actor.Pos, true), 30, Vector(), 5, 0, true) then
						self.target = actor;
					end
				end
			end
		end

	end
	if MovableMan:IsActor(self.target) then
		--FrameMan:DrawLinePrimitive(self.Pos, self.target.Pos, 0)
		local vec = SceneMan:ShortestDistance(self.Pos, self.target.Pos, true);
		if SceneMan:CastStrengthRay(self.Pos, vec, 30, Vector(), 5, 0, true) then
			self.target = nil;
			--print("ray nil");
		else
			if self.Ammo > 0 then
				if vec.X > 0 then
					self.AngularVel = self.AngularVel + 0.001;
				else
					self.AngularVel = self.AngularVel - 0.001;
				end
				if math.abs(self.AngularVel) > 0.2 then
					--print("firing");
					if self.frostTimer:IsPastSimMS(50) then
						self.frostTimer:Reset();
						
						local missile = CreateMOSRotating("Blizzard Shard", "AAA.rte");
						missile.Team = self.Team;
						missile.IgnoresTeamHits = true;
						missile.Pos = self.Pos;
						missile.Vel = Vector(60 + math.random() * 10, 0):RadRotate(vec.AbsRadAngle + 0.05 - math.random() * 0.1);
						--missile.Vel = Vector(70, 0):RadRotate(vec.AbsRadAngle);
						missile.Vel.Y = missile.Vel.Y - 0.5 * (SceneMan.GlobalAcc.Y * TimerMan.DeltaTimeSecs) * (vec.X/missile.Vel.Magnitude);
						MovableMan:AddParticle(missile);
						self.Ammo = self.Ammo - 1;
						self.Scale = self.Scale - 0.006;
					end
					
				end
			else
				self.target = nil;
				
			end
		end
	else
        self.target = nil;
		--print("actor nil");
	end
	if self.target == nil then
		if self.AngularVel > 0.02 then
			self.AngularVel = self.AngularVel - 0.002;
		elseif self.AngularVel < -0.02 then
			self.AngularVel = self.AngularVel + 0.002;
		else
			if self.Ammo < 14 then
				--print("reloaded");
				self.Ammo = 14;
				if self.Scale < 0.5 then
					StarGib(self);
					self:GibThis();
				end
			end
		end
	end
	if IsActor(self.owner) then
		if ToActor(self.owner):GetNumberValue("Star") ~= self.UniqueID then
			StarGib(self);
			self:GibThis();
		end
		if self.Team == self.owner.Team then
			--self.Pos = self.owner.Pos;
			--local target = Vector(0,0);
			--if SceneMan:CastObstacleRay(position, Vector(600,0):DegRotate(60), target, Vector(), actor.RootID, team, 128, 1) >= 0 then
			local cood = Vector(0,0);
			local angle = 0;
			if self.owner.HFlipped == true then
				angle = 60;
			else
				angle = 120;
			end
			--print(angle)
			if SceneMan:CastNotMaterialRay(self.owner.Pos, Vector(240,0):DegRotate(angle), 0, cood, 5, false) == true then
				cood = self.owner.Pos + SceneMan:ShortestDistance(self.owner.Pos,cood,true) * 0.7;
			else
				cood = self.owner.Pos + Vector(168,0):DegRotate(angle);
			end
			--FrameMan:DrawLinePrimitive(self.owner.Pos, cood, 0);
			local vec = SceneMan:ShortestDistance(self.Pos, cood, true)
			self.Pos = self.Pos + vec * 0.1;
			self.RotAngle = self.RotAngle + self.AngularVel;
			--self.Scale = self.Scale - 0.001;
		end
	else
		StarGib(self);
		self:GibThis();
	end
	
end

function Destroy(self)

	if IsActor(self.owner) and self.bind == true then
		if ToActor(self.owner):NumberValueExists("Star") == true then
			if ToActor(self.owner):GetNumberValue("Star") == self.UniqueID then
				ToActor(self.owner):RemoveNumberValue("Star");
			end
		end
	end

end