function IonStorm:StartScript()
	--print ("IonStorm:StartScript()")
end

function IonStorm:UpdateScript()
	--print ("IonStorm:UpdateScript()")
	
	if IonStormTable == nil then
		IonStormTable = {};
		IonStormTable[0] = 0;
	end
	
	if IonStormTable[0] >= 60 then
		for actor in MovableMan.Actors do
			if actor.Pos.Y < 250 and actor.Pos.Y > 50 then
				IonStormTable[0] = 0;
				local target = Vector(actor.Pos.X,0);
				if SceneMan:CastNotMaterialRay(Vector(target.X,-200), Vector(0,2000), 0, target, 0, true) == true then

					local explosion = CreateMOPixel("Lightning Glow", "AAA.rte");
					explosion.Pos = target;
					explosion.Vel = Vector(0,0);
					MovableMan:AddParticle(explosion);

					local PlayedSound = CreateAEmitter("Lightning Sound Emitter");
					PlayedSound.Pos = target;
					MovableMan:AddParticle(PlayedSound);
					
					for i = 1, 200 do
						local number = math.random (1, 3);
						local name = "Lightning Hurtful"
						if (number <= 1) then
							name = "Lightning Hurtful";
						elseif (number <= 2) then
							name = "Lightning Light Hurtful";
						else
							name = "Lightning Sparkle Hurtful";
						end
						local explosion = CreateMOPixel(name, "AAA.rte");
						explosion.Pos = target + Vector(math.random(-10,10),math.random(-10,10));
						explosion.Vel = Vector(70 + math.random() * 70,0):RadRotate(math.random() * 2 * math.pi);
						MovableMan:AddParticle(explosion);
					end
				end
			end
		end
	else
		IonStormTable[0] = IonStormTable[0] + 1;
	end
end

function IonStorm:EndScript()
	--print ("IonStorm:UpdateScript()")
end

function IonStorm:PauseScript()
	--print ("IonStorm:UpdateScript()")
end

function IonStorm:CraftEnteredOrbit()
	--print ("IonStorm:UpdateScript()")
end
