function Create(self)

	self.gotid = self.Sharpness;
	self.bind = false;
	if IsActor(MovableMan:GetMOFromID(self.gotid)) then
		self.owner = ToActor(MovableMan:GetMOFromID(self.gotid));
		if IsActor(self.owner) then
			ToActor(self.owner):SetNumberValue("Jam",self.UniqueID);
			self.bind = true;
		else
			self.owner = nil;
		end
	else
		self.owner = nil;
	end
	self.Sharpness = 0;
	self.flashTimer = Timer();
	self.flashDelay = 50;
end


function Update(self)

	if IsActor(self.owner) then
		if ToActor(self.owner):GetNumberValue("Jam") ~= self.UniqueID then
			self:GibThis();
		end
		
		local canParaFlash = false;
		if self.flashTimer:IsPastSimMS(self.flashDelay) then
			self.flashTimer:Reset();
			local effectPar = CreateMOPixel("Ronin Signal Jammer Glow Particle");
			effectPar.Pos = self.Pos;
			MovableMan:AddParticle(effectPar);
			canParaFlash = true;
		end
		if canParaFlash then
			ToActor(self.owner):FlashWhite(25);
		end
		
		ToActor(self.owner):GetController():SetState(Controller.BODY_JUMP,false);
		ToActor(self.owner):GetController():SetState(Controller.BODY_JUMPSTART,false);
		ToActor(self.owner):GetController():SetState(Controller.BODY_CROUCH,true);
		ToActor(self.owner):GetController():SetState(Controller.PIE_MENU_ACTIVE,false);
		ToActor(self.owner):GetController():SetState(Controller.WEAPON_FIRE,false);
		ToActor(self.owner):GetController():SetState(Controller.AIM_SHARP,false);
		ToActor(self.owner):GetController():SetState(Controller.MOVE_RIGHT,false);
		ToActor(self.owner):GetController():SetState(Controller.MOVE_LEFT,false);
		
		self.Pos = self.owner.Pos;
	else
		self:GibThis();
	end

end

function Destroy(self)
	
	if IsActor(self.owner) and self.bind == true then
		if ToActor(self.owner):NumberValueExists("Jam") == true then
			if ToActor(self.owner):GetNumberValue("Jam") == self.UniqueID then
				ToActor(self.owner):RemoveNumberValue("Jam");
			end
		end
	end

end