dofile("Base.rte/Constants.lua")
dofile("Base.rte/Actors/AI/HumanAI.lua")
dofile("AAA.rte/MAGen.lua")

function Create(self)

	self.AI = NativeHumanAI:Create(self)
	if self.Health > 70 then
		self.Health = 70;
	end
	self.element = 6;
	self.twiceChance = 0.0;
	self.freeChance = 0.4;
	self.dupeChance = 0.0;
	if ToActor(self):NumberValueExists("Summon") == false then
		ToActor(self):SetNumberValue("Summon", -4);
	end
	if ToActor(self):NumberValueExists("Element") == false then
		ToActor(self):SetNumberValue("Element", 6);
	end
	if ToActor(self):NumberValueExists("Max Mana") == false then
		ToActor(self):SetNumberValue("Max Mana", 280);
	end
	if ToActor(self):NumberValueExists("Mana") == false then
		ToActor(self):SetNumberValue("Mana", 280);
	end
	if ToActor(self):NumberValueExists("Mana Regen") == false then
		ToActor(self):SetNumberValue("Mana Regen", 6);
	end
	if ToActor(self):NumberValueExists("Spell Speed") == false then
		ToActor(self):SetNumberValue("Spell Speed", 0.9);
	end
	if ToActor(self):NumberValueExists("Spell Max") == false then
		ToActor(self):SetNumberValue("Spell Max", 6);
	end
	if ToActor(self):NumberValueExists("Efficiency") == false then
		ToActor(self):SetNumberValue("Efficiency", 1.0);
	end
	
	self.spellchoice = 1; --selected spell position in spelllist, only use in selection mode
	self.spellnumber = 1; --size of spelltable
	self.spelltable = {}; --start from 0
	
	self.spelltable[1] = 60;  --start w raise dead
	
	MageInit(self);

end

function UpdateAI(self)
   self.AI:Update(self)
end

function Update(self)
	MageStep(self);
end

function Destroy(self)
	--if self:NumberValueExists("Rebirth") ~= true then
	--ActivityMan:GetActivity():ReportDeath(self.Team,-1);
	if self.Sharpness ~= 4 then
		local explosion = CreateAEmitter("Necron Bolt", "AAA.rte");
		explosion.Pos = self.Pos + Vector(0,-8);
		explosion.Vel = Vector(0,-8);
		MovableMan:AddParticle(explosion);
		ToAEmitter(explosion):SetNumberValue("Team", self.Team);
		local number = math.random (1,4);
		if (number == 1) then
			ToAEmitter(explosion):SetStringValue("Name", "Skeleton Fire");
		elseif (number == 2) then
			ToAEmitter(explosion):SetStringValue("Name", "Skeleton Cold");
		elseif (number == 3) then
			ToAEmitter(explosion):SetStringValue("Name", "Skeleton Lightning");
		else
			ToAEmitter(explosion):SetStringValue("Name", "Skeleton Poison");
		end
	end
end