dofile("Base.rte/Constants.lua")
dofile("Base.rte/Actors/AI/HumanAI.lua")
dofile("AAA.rte/MAGen.lua")

function Create(self)
	self.AI = NativeHumanAI:Create(self)

	self.element = 5;
	self.twiceChance = 0.2;
	self.freeChance = 0.2;
	self.dupeChance = 0.3;
	if ToActor(self):NumberValueExists("Summon") == false then
		ToActor(self):SetNumberValue("Summon", -1);
	end
	if ToActor(self):NumberValueExists("Element") == false then
		ToActor(self):SetNumberValue("Element", 5);
	end
	if ToActor(self):NumberValueExists("Max Mana") == false then
		ToActor(self):SetNumberValue("Max Mana", 350);
	end
	if ToActor(self):NumberValueExists("Mana") == false then
		ToActor(self):SetNumberValue("Mana", 350);
	end
	if ToActor(self):NumberValueExists("Mana Regen") == false then
		ToActor(self):SetNumberValue("Mana Regen", 14);
	end
	if ToActor(self):NumberValueExists("Spell Speed") == false then
		ToActor(self):SetNumberValue("Spell Speed", 1);
	end
	if ToActor(self):NumberValueExists("Spell Max") == false then
		ToActor(self):SetNumberValue("Spell Max", 8);
	end
	if ToActor(self):NumberValueExists("Efficiency") == false then
		ToActor(self):SetNumberValue("Efficiency", 1.0);
	end
	
	self.spellchoice = 1; --selected spell position in spelllist, only use in selection mode
	self.spellnumber = 1; --size of spelltable
	self.spelltable = {}; --start from 0
	
	self.spelltable[1] = 50;  --start w arcane missile
	
	MageInit(self);

end

function UpdateAI(self)
   self.AI:Update(self)
end

function Update(self)
	MageStep(self);
end

function Destroy(self)

end