function Create(self)

	--self.alliedTeam = -1;
	self.stormTimer = Timer();

end

function Update(self)

	if self.stormTimer:IsPastSimMS(100) then
		self.stormTimer:Reset();
		local target = Vector(self.Pos.X + math.random(-5, 5),0);
		if SceneMan:CastNotMaterialRay(Vector(target.X,-200), Vector(0,2000), 0, target, 0, true) == true then

			local explosion = CreateMOPixel("Lightning Glow", "AAA.rte");
			explosion.Pos = target;
			explosion.Vel = Vector(0,0);
			MovableMan:AddParticle(explosion);

			local PlayedSound = CreateAEmitter("Lightning Sound Emitter");
			PlayedSound.Pos = target;
			MovableMan:AddParticle(PlayedSound);
			
			for i = 1, 200 do
				local number = math.random (1, 3);
				local name = "Lightning Hurtful"
				if (number <= 1) then
					name = "Lightning Hurtful";
				elseif (number <= 2) then
					name = "Lightning Light Hurtful";
				else
					name = "Lightning Sparkle Hurtful";
				end
				local explosion = CreateMOPixel(name, "AAA.rte");
				explosion.Pos = target + Vector(math.random(-10,10),math.random(-10,10));
				explosion.Vel = Vector(70 + math.random() * 70,0):RadRotate(math.random() * 2 * math.pi);
				MovableMan:AddParticle(explosion);
			end
		end
	end

end

function Destroy(self)

	for i = -5, 5 do
		local target = Vector(self.Pos.X + i,0);
		if SceneMan:CastNotMaterialRay(Vector(target.X,-200), Vector(0,2000), 0, target, 0, true) == true then

			local explosion = CreateMOPixel("Lightning Glow", "AAA.rte");
			explosion.Pos = target;
			explosion.Vel = Vector(0,0);
			MovableMan:AddParticle(explosion);

			local PlayedSound = CreateAEmitter("Lightning Sound Emitter");
			PlayedSound.Pos = target;
			MovableMan:AddParticle(PlayedSound);
			
			for i = 1, 200 do
				local number = math.random (1, 3);
				local name = "Lightning Hurtful"
				if (number <= 1) then
					name = "Lightning Hurtful";
				elseif (number <= 2) then
					name = "Lightning Light Hurtful";
				else
					name = "Lightning Sparkle Hurtful";
				end
				local explosion = CreateMOPixel(name, "AAA.rte");
				explosion.Pos = target + Vector(math.random(-10,10),math.random(-10,10));
				explosion.Vel = Vector(70 + math.random() * 70,0):RadRotate(math.random() * 2 * math.pi);
				MovableMan:AddParticle(explosion);
			end
		end
	end
end