function Create(self)
	local targetpt = Vector(self.Pos.X,self.Pos.Y);
	if SceneMan:CastStrengthRay(self.Pos,Vector(0,-400),0,targetpt,0,0,false) == true then
	--if SceneMan:CastNotMaterialRay(self.Pos, Vector(0,-500), 0, targetpt, 0, true) == true then
		local Effect = CreateMOSRotating("Grapple Fix", "AAA.rte");
		Effect.Pos = targetpt;
		--Effect:SetWhichMOToNotHit(actor, 0.1)
		Effect.Team = self.Team;
		Effect.Sharpness = self.RootID;
		Effect.IgnoresTeamHits = true;
		--Add the particle to the world.
		MovableMan:AddParticle(Effect);
	end
	self.target = nil;
	self.targetDist = 400;
end

function Update(self)

	self.RotAngle = 0;
	if math.random(1,30) == 30 then
		if not MovableMan:IsActor(self.target) or self.target.Team == self.Team then
			--Find a target.
			for actor in MovableMan.Actors do
				if actor.Team ~= self.Team then
					if SceneMan:ShortestDistance(self.Pos, actor.Pos, true).Magnitude < self.targetDist then
						if not SceneMan:CastStrengthRay(self.Pos, SceneMan:ShortestDistance(self.Pos, actor.Pos, true), 30, Vector(), 5, 0, true) then
							self.target = actor;
						end
					end
				end
			end

		end
		if MovableMan:IsActor(self.target) then
			--FrameMan:DrawLinePrimitive(self.Pos, self.target.Pos, 0)
			local vec = SceneMan:ShortestDistance(self.Pos, self.target.Pos, true);
			if SceneMan:CastStrengthRay(self.Pos, vec, 30, Vector(), 5, 0, true) then
				self.target = nil;
				--print("ray nil");
			else
				local effect = CreateMOSRotating("Pixieswarm Canister Effect", "AAA.rte");
				effect.Pos = self.Pos;
				MovableMan:AddParticle(effect);
				effect:GibThis();
				local swarm = CreateAEmitter("Pixieswarm", "AAA.rte");
				swarm.Pos = self.Pos;
				swarm.Team = self.Team;
				swarm.Sharpness = self.target.RootID;
				MovableMan:AddParticle(swarm);
				self:GibThis();
			end
		else
			self.target = nil;
			--print("actor nil");
		end
	end
	
end

function Destroy(self)

end