function Create(self)

	self.delayTimer = Timer();
	--self.overallTimer = Timer();
	--self.scanTimer = Timer();
	self.actionPhase = 0;
	--self.blink = false;
	self.fireOn = false;

end

function Update(self)
--[[
	if self.ID ~= self.RootID then
		if self.scanTimer:IsPastSimMS(500) then
			self.scanTimer:Reset();
			if coalitionMineTable ~= nil then
				for i = 1, #coalitionMineTable do
					if MovableMan:IsParticle(coalitionMineTable[i]) and SceneMan:ShortestDistance(self.Pos,coalitionMineTable[i].Pos,SceneMan.SceneWrapsX).Magnitude < 100 then
						local detectPar = CreateMOPixel("Disarmer Detection Particle");
						detectPar.Pos = coalitionMineTable[i].Pos;
						MovableMan:AddParticle(detectPar);
					end
				end
			end

			if coalitionC4TableA ~= nil and coalitionC4TableB ~= nil then
				for i = 1, #coalitionC4TableA do
					if MovableMan:IsParticle(coalitionC4TableA[i]) and SceneMan:ShortestDistance(self.Pos,coalitionC4TableA[i].Pos,SceneMan.SceneWrapsX).Magnitude < 100 then
						local detectPar = CreateMOPixel("Disarmer Detection Particle");
						detectPar.Pos = coalitionC4TableA[i].Pos;
						MovableMan:AddParticle(detectPar);
					end
				end
			end
		end
	end
]]
	if self:IsActivated() then

		if self.fireOn == false then
			self.Magazine.RoundCount = 200-self.delayTimer.ElapsedSimTimeMS;
			if self.delayTimer:IsPastSimMS(200) then
				self.delayTimer:Reset();
				self.actionPhase = self.actionPhase + 1;
				--self.blink = false;
			end
			if self.actionPhase == 1 then
			--[[
				if coalitionMineTable ~= nil then
					for i = 1, #coalitionMineTable do
						if MovableMan:IsParticle(coalitionMineTable[i]) and SceneMan:ShortestDistance(self.Pos,coalitionMineTable[i].Pos,SceneMan.SceneWrapsX).Magnitude < 100 then
							local storePos = coalitionMineTable[i].Pos;
							coalitionMineTable[i].Sharpness = 1;
						--	coalitionMineTable[i].ToDelete = true;
							local mine = CreateTDExplosive("Anti Personnel Mine");
							mine.Pos = storePos;
							MovableMan:AddParticle(mine);
						end
					end
				end

				if coalitionC4TableA ~= nil and coalitionC4TableB ~= nil then
					for i = 1, #coalitionC4TableA do
						if MovableMan:IsParticle(coalitionC4TableA[i]) and SceneMan:ShortestDistance(self.Pos,coalitionC4TableA[i].Pos,SceneMan.SceneWrapsX).Magnitude < 100 then
							local storePos = coalitionC4TableA[i].Pos;
							coalitionC4TableA[i].Sharpness = 1;
						--	coalitionC4TableA[i].ToDelete = true;
							local c4 = CreateTDExplosive("Remote Explosive");
							c4.Pos = storePos;
							MovableMan:AddParticle(c4);
						end
					end
				end

				local soundfx = CreateAEmitter("Disarmer Sound Disarm");
				soundfx.Pos = self.Pos;
				MovableMan:AddParticle(soundfx);
				self.fireOn = true;
				]]
				if self.ID ~= self.RootID then
					local actor = MovableMan:GetMOFromID(self.RootID);
					if MovableMan:IsActor(actor) then
						ToActor(actor).Health = ToActor(actor).Health - 5;
						local explosion = CreateMOSRotating("Particle Blood Explosion", "AAA.rte");
						if explosion then
							explosion.Pos = actor.Pos;
							explosion.Vel = Vector(0,0);
							MovableMan:AddParticle(explosion);
							explosion:GibThis();
						end
						if ToActor(actor):NumberValueExists("Mana") then
							for i = 1, 3, 1 do
								local flicker = CreateAEmitter("AAA.rte/Flymana");
								if flicker then
									flicker.Pos = actor.Pos + Vector(math.random(40,100),0):RadRotate(math.random() * 2 * math.pi);
									flicker.Sharpness = actor.ID;
									MovableMan:AddParticle(flicker);
								end
							end
						end
						--[[
						if ToActor(actor).Health <= 0 then
							for tester in MovableMan.Particles do
								if tester.PresetName == "Summoning Glyph" then
									if tester.Team == ToActor(actor).Team then
										if SceneMan:ShortestDistance(ToActor(actor).Pos, tester.Pos, true).Magnitude < 50 then
											print("demon");
											local explosion = CreateMOSRotating("Particle Summon Explosion", "AAA.rte");
											explosion.Pos = ToActor(actor).Pos + Vector(0,-6);
											explosion.Vel = Vector(0,0);
											MovableMan:AddParticle(explosion);
											explosion:GibThis();
											
											local PlayedSound = CreateAEmitter("Summon Sound Emitter");
											PlayedSound.Pos = ToActor(actor).Pos;
											MovableMan:AddParticle(PlayedSound);
											
											local summon = CreateACrab("Aphid Demon", "AAA.rte");
											summon.Team = ToActor(actor).Team;
											summon.Pos = ToActor(actor).Pos;
											summon.Vel = Vector(0,0);
											if math.random(1,2) == 2 then
												summon.HFlipped = true;
											end
											
											if actor ~= nil then
												summon.AIMode = actor.AIMode;
											else
												summon.AIMode = Actor.AIMODE_SENTRY;
											end
											MovableMan:AddActor(summon);
											summon:FlashWhite(200);
											
											local pylon = 4;
											for tester in MovableMan.Actors do
												if tester.PresetName == "Necromancer" then
													if tester.Team == ToActor(actor).Team then
														pylon = pylon + 6;
													end
												end
												if ToActor(tester):NumberValueExists("Summon") then
													if tester.Team == ToActor(actor).Team then
														pylon = pylon - ToActor(tester):GetNumberValue("Summon");
													end
												end
											end
											print(pylon);
											if pylon <= 0 then
												summon:GibThis();
											end
											ToActor(actor).Health = -4444;
											ToActor(actor).Sharpness = 4;
											ToActor(actor):GibThis();
											break;
										end
									end
								end
							end
						end
						]]
					end
				end
				
				--self.delayTimer:Reset();
				--self.overallTimer:Reset();
				--self.Magazine.RoundCount = 1000;
				self.fireOn = true;
				--self.actionPhase = 0;
				
			end
		end
	else
		self.delayTimer:Reset();
		--self.overallTimer:Reset();
		self.Magazine.RoundCount = 200;
		self.fireOn = false;
		self.actionPhase = 0;
	end

end