function Create(self)
	self.spell = self.Sharpness % 100;
	self.alliedTeam = (self.Sharpness - self.spell) / 100;
	self.Sharpness = 0;
end

function Update(self)
	if self.ID ~= self.RootID then
		local actor = MovableMan:GetMOFromID(self.RootID);
		if MovableMan:IsActor(actor) then
			self.alliedTeam = ToActor(actor).Team;
		end
	end
	
	if self:IsActivated() and self.ID == self.RootID then
		local explosive = CreateMOSRotating("Particle Active Rollerbomb");
			explosive.Pos = self.Pos;
			explosive.Vel = self.Vel;
			explosive.RotAngle = self.RotAngle;
			explosive.Sharpness = self.alliedTeam * 100 + self.spell;
			explosive.HFlipped = self.HFlipped;
			MovableMan:AddParticle(explosive);

			self.ToDelete = true;
	end
end