function Create(self)
	if self.Magazine then --have mag
		self.ammo = self.Magazine.RoundCount --have ammo
	else--no mag
		self.ammo = 0 --no ammo
	end	
	
end

function Update(self)
	if self.Magazine then --have mag
		if self.ammo > self.Magazine.RoundCount then
			-- bullets are missing from the magazine so the gun must have been fired
			
			--local Parent = MovableMan:GetMOFromID(self.RootID) --get thing holding gun and store as parent
			local Parent = ToActor(MovableMan:GetMOFromID(self.RootID))
			--local BulletVel = self.Vel + self:RotateOffset(Vector(170,RangeRand(-3,3))) --set bullet velocity adnd direction
			
			-- bullets
			if self.HFlipped == false then
				self.negativeNum = 1;
			else
				self.negativeNum = -1;
			end
			
			local Target = Vector(0,0);
			if SceneMan:CastNotMaterialRay(self.Pos, Vector(900*self.negativeNum,0):RadRotate(self.RotAngle), 0, Target, 0, false) == true then
				for actor in MovableMan.Actors do
					if actor.Team ~= self.Team then
						if SceneMan:ShortestDistance(Target, actor.Pos, true).Magnitude < 35 then
							actor.Health = actor.Health - 3;
							local flicker = CreateAEmitter("AAA.rte/Flyblood");
							if flicker then
								flicker.Pos = actor.Pos + Vector(math.random(0,6),0):RadRotate(math.random() * 2 * math.pi);
								flicker.Sharpness = Parent.ID;
								MovableMan:AddParticle(flicker);
							end
							if actor:NumberValueExists("Mana") and actor:GetNumberValue("Mana") >= 20 then
								actor:SetNumberValue("Mana", actor:GetNumberValue("Mana") - 20);
								local flicker = CreateAEmitter("AAA.rte/Flymana");
								if flicker then
									flicker.Pos = actor.Pos + Vector(math.random(0,6),0):RadRotate(math.random() * 2 * math.pi);
									flicker.Sharpness = Parent.ID;
									MovableMan:AddParticle(flicker);
								end
							end
						end
					end
				end

			end
		end
		
		-- update the ammo counter so this script can't spawn bullets until the gun has been fired again
		self.ammo = self.Magazine.RoundCount
	end

end
