function Create(self)

	self.Pos.Y = self.Pos.Y + self:GetAltitude(0,0) - 30
	self.gotid = self.Sharpness;
	self.bind = false;
	if IsActor(MovableMan:GetMOFromID(self.gotid)) then
		self.owner = ToActor(MovableMan:GetMOFromID(self.gotid));
		if IsActor(self.owner) then
			if ToActor(self.owner):NumberValueExists("Rebirth") ~= true then
				ToActor(self.owner):SetNumberValue("Rebirth",self.ID);
				self.bind = true;
			else
				--print("TRUE DEATH");
				ToActor(self.owner).Health = -4444;
				ToActor(self.owner).Sharpness = 4;
				self.ToDelete = true;
			end
		else
			--print("TRUE DEATH");
			self.ToDelete = true;
		end
	else
		--print("TRUE DEATH");
		self.ToDelete = true;
	end
	self.Sharpness = 0;
	self.chargeTimer = Timer();
	self.stage = 0;
	self.loc = Vector(0,0);
	--self.frac = 0;
end

function Update(self)

	if self.stage == 0 then
		if IsActor(self.owner) then
			self.targetx = self.owner.Pos.X;
			self.targety = self.owner.Pos.Y;
			--print(self.loc);
		else
			self.loc.X = self.targetx;
			self.loc.Y = self.targety;

			self.x1 = self.Pos.X + (self.loc.X - self.Pos.X + math.random(-1000,1000)) * math.random();
			self.y1 = self.Pos.Y + (self.loc.Y - self.Pos.Y + math.random(-1000,1000)) * math.random();
			self.x2 = self.Pos.X + (self.loc.X - self.Pos.X + math.random(-1000,1000)) * math.random();
			self.y2 = self.Pos.Y + (self.loc.Y - self.Pos.Y + math.random(-1000,1000)) * math.random();
			
			self.ax1 = self.Pos.X + (self.loc.X - self.Pos.X) + math.random(-400,400) * math.random();
			self.ay1 = self.Pos.Y + (self.loc.Y - self.Pos.Y + math.random(-400,400)) * math.random();
			self.ax2 = self.Pos.X + (self.loc.X - self.Pos.X + math.random(-400,400)) * math.random();
			self.ay2 = self.Pos.Y + (self.loc.Y - self.Pos.Y + math.random(-400,400)) * math.random();

			self.cx = 3 * (self.x1 - self.loc.X);
			self.bx = 3 * (self.x2 - self.x1) - self.cx;
			self.ax = self.Pos.X - self.loc.X - self.cx - self.bx;
			self.cy = 3 * (self.y1 - self.loc.Y);
			self.by = 3 * (self.y2 - self.y1) - self.cy;
			self.ay = self.Pos.Y - self.loc.Y - self.cy - self.by;
			
			self.acx = 3 * (self.ax1 - self.loc.X);
			self.abx = 3 * (self.ax2 - self.ax1) - self.acx;
			self.aax = self.Pos.X - self.loc.X - self.acx - self.abx;
			self.acy = 3 * (self.ay1 - self.loc.Y);
			self.aby = 3 * (self.ay2 - self.ay1) - self.acy;
			self.aay = self.Pos.Y - self.loc.Y - self.acy - self.aby;

			self.chargeTimer:Reset();
			self.stage = 1;
		end
	elseif self.stage == 1 then
	--[[
		local frac = (5000 - self.chargeTimer.ElapsedSimTimeMS)/ 5000;

		local point = CreateMOSParticle("Magic Soul Particle", "AAA.rte");
		point.Pos = self.Pos + (self.loc - self.Pos) * frac;
		point.Vel = Vector(0,0);
		MovableMan:AddParticle(point);
		if self.chargeTimer:IsPastSimMS(5000) then
			self:GibThis();
		end
		]]
		local frac = (self.chargeTimer.ElapsedSimTimeMS) * 0.00025; --4000ms
		if frac <= 1 and frac >= 0 then
			local point = CreateMOSParticle("Magic Soul Particle", "AAA.rte");
			point.Pos.X = ((self.ax * frac + self.bx) * frac + self.cx) * frac + self.loc.X;
			point.Pos.Y = ((self.ay * frac + self.by) * frac + self.cy) * frac + self.loc.Y;
			point.Vel = Vector(0,0);
			MovableMan:AddParticle(point);
			local point = CreateMOSParticle("Magic Spirit Particle", "AAA.rte");
			point.Pos.X = ((self.aax * frac + self.abx) * frac + self.acx) * frac + self.loc.X;
			point.Pos.Y = ((self.aay * frac + self.aby) * frac + self.acy) * frac + self.loc.Y;
			point.Vel = Vector(0,0);
			MovableMan:AddParticle(point);
		end
		if self.chargeTimer:IsPastSimMS(5000) then
			local PlayedSound = CreateAEmitter("Ankh Sound Emitter");
			PlayedSound.Pos = self.Pos;
			MovableMan:AddParticle(PlayedSound);
			ActivityMan:GetActivity():ReportDeath(self.Team,-1);
			self:GibThis();
		end
	end
	if self.Health < 100 or self.TotalWoundCount > 1 then
		local PlayedSound = CreateAEmitter("Scream Sound Emitter");
		PlayedSound.Pos = self.Pos;
		MovableMan:AddParticle(PlayedSound);
		self.ToDelete = true;
	end
end

function Destroy(self)
	ActivityMan:GetActivity():ReportDeath(self.Team,-1);
	if IsActor(self.owner) and self.bind == true then
		if ToActor(self.owner):NumberValueExists("Rebirth") == true then
			ToActor(self.owner):RemoveNumberValue("Rebirth");
		end
		ToActor(self.owner).Health = -4444;
	end
end