--package.loaded.Constants = nil; require("Constants")
dofile("AAA.rte/SpellFunctions.lua")

function Create(self)
	if MechSelectTable == nil then
		MechSelectTable = {};
		MechSelectTable[0] = nil;
		MechSelectTable[1] = nil;
		MechSelectTable[2] = nil;
		MechSelectTable[3] = nil;
	end
	MechSelectTable[self.Team] = nil;

	self.PresetName = "Mechanism";
	self.spell = self.Sharpness;
	self.Sharpness = 0;
	self.spellname, self.spellcost, self.spellcast, self.spellrange, self.spellmode = SpellGet(self.spell);
	self.mana = 300;
	self.maxmana = 300;
	self.manaregen = 30;
	
	self.chargeTimer = Timer();
	self.regenTimer = Timer();
	
end

function Update(self)

	if self.regenTimer:IsPastSimMS(1000) then
		self.regenTimer:Reset();
		self.mana = math.min(self.maxmana, self.mana + self.manaregen);
	end

	if self.mana >= self.spellcost then
		if self.chargeTimer:IsPastSimMS(self.spellcast) then
			if self.Sharpness > 0 then
				SpellCast(self.spell, nil, self.Pos, self.Pos, self.RotAngle, self.Team);
				self.mana = self.mana - self.spellcost;
				self.chargeTimer:Reset();
			end
		end
	end
	
	self.Sharpness = 0;

end

function Destroy(self)

end