--package.loaded.Constants = nil; require("Constants")
dofile("AAA.rte/SpellFunctions.lua")

function Create(self)

	--self.PresetName = "Spell Mine";
	
	if spellMechDirTable == nil then
		spellMechDirTable = {};
		spellMechDirTable[0] = 0;
		spellMechDirTable[1] = 0;
		spellMechDirTable[2] = 0;
		spellMechDirTable[3] = 0;
	end
	--self.PresetName = "Spell Mechanism";
	self.RotAngle = spellMechDirTable[self.Team];

	self.pulseTimer = Timer();
	self.blinkTimer = Timer();
	self.dustTimer = Timer();
	self.actionPhase = 1;
	self.faceDirection = self.RotAngle+(math.pi/2);
	self.dustDelay = 0;
	self.tempLaserLength = 0;

	self.laserLength = 80;
	self.minVisualDelay = 0;
	self.maxVisualDelay = 200;

	--self.spell = self.Sharpness % 100;
	self.alliedTeam = self.Team;
	self.Sharpness = 0;

	self.blink = false;
	self.Frame = (self.alliedTeam+1)*2;
--[[
	if spellTrapTable == nil then
		spellTrapTable = {};
	end

	self.tableNum = #spellTrapTable+1;
	spellTrapTable[self.tableNum] = self;
]]
	self.delayTimer = Timer();
	self.manacost = 0;
	self.manaregen = self.Sharpness;
	self.Sharpness = 0;

	self.spellnumber = 0; --size of spelltable
	self.spelltable = {}; --start from 1
	self.spellx = {}; --start from 1
	self.spelly = {}; --start from 1
	self.spelldir = {}; --start from 1
	
	for parti in MovableMan.Particles do
		if parti.Team == self.Team then
			--if string.find(parti.PresetName, "Mechanism") ~= nil then
			if parti.PresetName == "Spell Mechanism" then
				if SceneMan:ShortestDistance(parti.Pos, self.Pos, true).Magnitude <= 1000 then
					self.spellnumber = self.spellnumber + 1;
					self.spelltable[self.spellnumber] = parti.Sharpness;
					self.spellx[self.spellnumber] = parti.Pos.X;
					self.spelly[self.spellnumber] = parti.Pos.Y;
					self.spelldir[self.spellnumber] = parti.RotAngle;
					self.spellname, self.spellcost, self.spellcast, self.spellrange, self.spellmode = SpellGet(parti.Sharpness);
					self.manacost = self.manacost + self.spellcost;
					parti.ToDelete = true;
				end
			end
		end
	end
	
	self.delay = math.max(500,1000 * math.ceil(self.manacost / self.manaregen));
end

function Update(self)
--[[
	if self.Sharpness == 0 then
		self.ToDelete = false;
		self.ToSettle = false;
		
		if spellTrapTable == nil then
			spellTrapTable = {};
			spellTrapTable[self.tableNum] = self;
		end
	else
		self.ToDelete = true;
	end]]

	if self.actionPhase == 1 and self.delayTimer:IsPastSimMS(self.delay) then

		if self.blinkTimer:IsPastSimMS(500) then

			self.blinkTimer:Reset();

			if self.blink == false then
				self.blink = true;
				self.Frame = (self.alliedTeam+1)*2;
			else
				self.blink = false;
				self.Frame = ((self.alliedTeam+1)*2)+1;
			end

		end

		if self.pulseTimer:IsPastSimMS(100) then

			self.pulseTimer:Reset();

			local rayHitPos = Vector(0,0);
			local terrainRaycast = SceneMan:CastStrengthRay(self.Pos,Vector(self.laserLength,0):RadRotate(self.faceDirection),0,rayHitPos,0,0,SceneMan.SceneWrapsX);

			if terrainRaycast == true then
				self.tempLaserLength = SceneMan:ShortestDistance(self.Pos,rayHitPos,SceneMan.SceneWrapsX).Magnitude;
			else
				self.tempLaserLength = self.laserLength;
			end

			local raycast = SceneMan:CastMORay(self.Pos,Vector(self.tempLaserLength,0):RadRotate(self.faceDirection),self.ID,self.alliedTeam,0,false,4);
			if raycast ~= 255 then
				local targetpart = MovableMan:GetMOFromID(raycast);
				local target = MovableMan:GetMOFromID(targetpart.RootID);
				if MovableMan:IsActor(target) then
					if ToActor(target).Team ~= self.alliedTeam then
						--SpellCast(self.spell, ToActor(target), self.Pos, self.Pos, self.RotAngle + 3.14 / 2, self.alliedTeam);
						--CAST HERE
						self.actionPhase = 2;
						self.blink = false;
					end
				else
					self.actionPhase = 2;
					self.blink = false;
				end
			end

		end

		if self.dustTimer:IsPastSimMS(self.dustDelay) then

			local dustBrightness = math.ceil(math.random()*7);

			if dustBrightness > 0 then

				self.dustTimer:Reset();
				self.dustDelay = (math.random()*(self.maxVisualDelay-self.minVisualDelay))+self.minVisualDelay;

				local dustPos = (math.random()*(self.tempLaserLength-3))+3;

				local effectpar = CreateMOPixel("Trap Laser Particle "..dustBrightness);
				effectpar.Pos = self.Pos + Vector(dustPos,0):RadRotate(self.faceDirection);
				MovableMan:AddParticle(effectpar);

				if dustBrightness >= 3 then
					local effectpar = CreateMOPixel("Trap Laser Particle "..(dustBrightness-2));
					effectpar.Pos = self.Pos + Vector(dustPos+2,0):RadRotate(self.faceDirection);
					MovableMan:AddParticle(effectpar);

					local effectpar = CreateMOPixel("Trap Laser Particle "..(dustBrightness-2));
					effectpar.Pos = self.Pos + Vector(dustPos-2,0):RadRotate(self.faceDirection);
					MovableMan:AddParticle(effectpar);

					if dustBrightness >= 5 then
						local effectpar = CreateMOPixel("Trap Laser Particle "..(dustBrightness-4));
						effectpar.Pos = self.Pos + Vector(dustPos+4,0):RadRotate(self.faceDirection);
						MovableMan:AddParticle(effectpar);

						local effectpar = CreateMOPixel("Trap Laser Particle "..(dustBrightness-4));
						effectpar.Pos = self.Pos + Vector(dustPos-4,0):RadRotate(self.faceDirection);
						MovableMan:AddParticle(effectpar);
					end
				end
			end

		end

	elseif self.actionPhase == 2 then

		if self.blink == false then
			self.blink = true;
			self.Frame = ((self.alliedTeam+1)*2)+1;
			self.pulseTimer:Reset();
			local soundfx = CreateAEmitter("Cage Down Sound Emitter");
			soundfx.Pos = self.Pos;
			MovableMan:AddParticle(soundfx);
		end

		if self.pulseTimer:IsPastSimMS(300) then
			--CAST HERE
			if self.spellnumber > 0 then
				for i = 1, self.spellnumber do
					local position = Vector(self.spellx[i],self.spelly[i]);
					SpellCast(self.spelltable[i], nil, position, position, self.spelldir[i], -1);
				end
			end
			self.actionPhase = 1;
			self.delayTimer:Reset();
		end

	end

end

function Destroy(self)

	--spellTrapTable[self.tableNum] = nil;

end