function Create(self)

	self.alliedTeam = -1;

end

function Update(self)

	if self.ID ~= self.RootID then
		local actor = MovableMan:GetMOFromID(self.RootID);
		if MovableMan:IsActor(actor) then
			if self.alliedTeam == -1 then
				self.alliedTeam = ToActor(actor).Team;
			end
		end
	else
		if self.PresetName ~= "Bound Tome" then
			self.PresetName = "Bound Tome";
		end
		if self.SharpLength ~= 0 then
			self.SharpLength = 0;
		end
		if self.alliedTeam ~= -1 then
			self:GibThis();
		end
	end

end

function Destroy(self)
	local explosion = CreateMOSRotating("Particle Blink Explosion", "AAA.rte");
	explosion.Pos = self.Pos;
	explosion.Vel = Vector(0,-20);
	MovableMan:AddParticle(explosion);
end