function Create(self)

	--self.alliedTeam = -1;
	--self.regenTimer = Timer();
	self.frostTimer = Timer();
	--self.iceTimer = Timer();
	self.arcticTimer = Timer();
	self.emberTimer = Timer();
	self.fireTimer = Timer();
	self.stoneTimer = Timer();
	self.stormTimer = Timer();
	

end

function Update(self)

	if self.frostTimer:IsPastSimMS(75) then
		self.frostTimer:Reset();
		
		local explosion = CreateMOSRotating("Blizzard Shard", "AAA.rte");
		explosion.Pos.X = self.Pos.X + math.random(-500, 500);
		explosion.Pos.Y = -200;
		explosion.Vel = Vector(0, 60 + math.random() * 10):RadRotate(0.05 - math.random() / 10);
		MovableMan:AddParticle(explosion);
	end
	--[[
	if self.iceTimer:IsPastSimMS(50) then
		self.iceTimer:Reset();

		local explosion = CreateMOPixel("Blizzard Particle Sharp", "AAA.rte");
		explosion.Pos.X = self.Pos.X + math.random(-500, 500);
		explosion.Pos.Y = -200;
		explosion.Vel = Vector(0, 60 + math.random() * 10):RadRotate(0.05 - math.random() / 10);
		MovableMan:AddParticle(explosion);
	end
	]]
	if self.arcticTimer:IsPastSimMS(900) then
		self.arcticTimer:Reset();
		local explosion = CreateMOSRotating("Arctic Lance", "AAA.rte");
		explosion.Pos.X = self.Pos.X + math.random(-500, 500);
		explosion.Pos.Y = -200;
		explosion.Vel = Vector(0, 35 + math.random() * 5):RadRotate(0.05 - math.random() / 10);
		MovableMan:AddParticle(explosion);
	end
	
	if self.emberTimer:IsPastSimMS(450) then
		self.emberTimer:Reset();
		local explosion = CreateAEmitter("Fireballbolt", "AAA.rte");
		explosion.Pos.X = self.Pos.X + math.random(-500, 500);
		explosion.Pos.Y = -200;
		explosion.Vel = Vector(0, 40 + math.random() * 10):RadRotate(0.05 - math.random() / 10);
		MovableMan:AddParticle(explosion);
		
		local explosion = CreateMOSRotating("Firestone Particle", "AAA.rte");
		explosion.Pos.X = self.Pos.X + math.random(-500, 500);
		explosion.Pos.Y = -200;
		explosion.Vel = Vector(0, 40 + math.random() * 10):RadRotate(0.05 - math.random() / 10);
		MovableMan:AddParticle(explosion);
		
	end
	
	if self.fireTimer:IsPastSimMS(3000) then
		self.fireTimer:Reset();
		local explosion = CreateAEmitter("Fireball", "AAA.rte");
		explosion.Pos.X = self.Pos.X + math.random(-500, 500);
		explosion.Pos.Y = -200;
		explosion.Vel = Vector(0, 25 + math.random() * 5):RadRotate(0.05 - math.random() / 10);
		MovableMan:AddParticle(explosion);
	end
	
	if self.stoneTimer:IsPastSimMS(300) then
		self.stoneTimer:Reset();
		local target = Vector(self.Pos.X + math.random(-500, 500),0);
		if SceneMan:CastNotMaterialRay(Vector(target.X,-200), Vector(0,2000), 0, target, 0, false) == true then
			local explosion = CreateMOSRotating("Particle Summon Explosion", "AAA.rte");
			explosion.Pos = target + Vector(0,-6);
			explosion.Vel = Vector(0,0);
			MovableMan:AddParticle(explosion);
			explosion:GibThis();
			
			local sel = MovableMan:GetClosestEnemyActor(-1, target, 100, Vector());
			if sel ~= nil then
				--sel.Mass = sel.Mass * math.min(1.0,sel.Vel.Magnitude);
				--print(sel.Mass);
				sel.Vel.X = sel.Vel.X + math.random(-8,8);
				sel.Vel.Y = sel.Vel.Y + math.random(-20,-10);
			end
			local explosion = CreateMOSRotating("Rising Earth", "AAA.rte");
			explosion.Pos.X = target.X;
			explosion.Pos.Y = target.Y - 15;
			explosion.Vel = Vector(0,0);
			MovableMan:AddParticle(explosion);
		end
	end
	
	if self.stormTimer:IsPastSimMS(1000) then
		self.stormTimer:Reset();
		local target = Vector(self.Pos.X + math.random(-500, 500),0);
		if SceneMan:CastNotMaterialRay(Vector(target.X,-200), Vector(0,2000), 0, target, 0, false) == true then
		
			local explosion = CreateMOPixel("Lightning Glow", "AAA.rte");
			explosion.Pos = target;
			explosion.Vel = Vector(0,0);
			MovableMan:AddParticle(explosion);

			local PlayedSound = CreateAEmitter("Lightning Sound Emitter");
			PlayedSound.Pos = target;
			MovableMan:AddParticle(PlayedSound);
			
			for i = 1, 200 do
				local number = math.random (1, 3);
				local name = "Lightning Hurtful"
				if (number <= 1) then
					name = "Lightning Hurtful";
				elseif (number <= 2) then
					name = "Lightning Light Hurtful";
				else
					name = "Lightning Sparkle Hurtful";
				end
				local explosion = CreateMOPixel(name, "AAA.rte");
				explosion.Pos = target + Vector(math.random(-8,8),math.random(-8,8));
				explosion.Vel = Vector(70 + math.random() * 70,0):RadRotate(math.random() * 2 * math.pi);
				MovableMan:AddParticle(explosion);
			end
		end
	end

end