--[[
function Create(self)
	--Scan all actors
	for actor in MovableMan.Actors do
		--Do some trigonometry to find the closest actor within 20 pixels
		local avgx = actor.Pos.X - self.Pos.X;
		local avgy = actor.Pos.Y - self.Pos.Y;
		local dist = math.sqrt(avgx ^ 2 + avgy ^ 2);
		if dist < 100 then
			--Store the selected actor for later use
			if MovableMan:IsActor(actor) then
      				ToActor(actor):AddHealth(-1);
			end
		end
	end
end
]]
--[[
function Create(self)
	--Scan all actors
	actor = MovableMan:GetMOFromID(self.RootID)
	print(self.RootID)
	print(actor)
	print(ToActor(actor))
	if MovableMan:IsActor(actor) then
      		ToActor(actor):AddHealth(-1);
	end
end

function Update(self)
	self.Parent = MovableMan:GetMOFromID(MovableMan:GetRootMOID(self.RootID));
	print(self)
	print(self.Parent)
	if MovableMan:IsActor(self.Parent) then
		self.Parent = ToActor(self.Parent);
		self.Parent:AddHealth(-1);
	end
end]]

function Create(self)

	self.reloaded = false;
	self.ammoCounter = 0;

end

function Update(self)
	if self.Magazine ~= nil then
		if self.reloaded == false then
			local actor = MovableMan:GetMOFromID(self.RootID);
			if MovableMan:IsActor(actor) then
				local flicker = CreateAEmitter("AAA.rte/Flyblood");
				if flicker then
					flicker.Pos = actor.Pos + Vector(math.random(40,100),0):RadRotate(math.random() * 2 * math.pi);
					flicker.Sharpness = actor.ID;
					MovableMan:AddParticle(flicker);
				end
			end
			self.reloaded = true;
			self.ammoCounter = self.Magazine.RoundCount;
		else
			if self.ammoCounter ~= self.Magazine.RoundCount then

				local actor = MovableMan:GetMOFromID(self.RootID);
				if MovableMan:IsActor(actor) then
--				and ToActor(actor):IsPlayerControlled() then
					ToActor(actor):AddHealth(-1);
				end


			end
			self.ammoCounter = self.Magazine.RoundCount;
		end
	else
		self.reloaded = false;
	end
end