function Create(self)

	self.alliedTeam = -1;
	self.regenTimer = Timer();
	self.limit = self.WoundCount;
	self.acti = false;
	--print("create end");
end

function Update(self)
	
	if self.ID ~= self.RootID then
		--print("rooted");
		local actor = MovableMan:GetMOFromID(self.RootID);
		if MovableMan:IsActor(actor) then
			if self.alliedTeam == -1 then
				self.alliedTeam = ToActor(actor).Team;
			end
			if self.regenTimer:IsPastSimMS(1000) then
				self.regenTimer:Reset();
				if ToActor(actor):NumberValueExists("Bonus Mana") then
					ToActor(actor):SetNumberValue("Bonus Mana", ToActor(actor):GetNumberValue("Bonus Mana") + 4);
				end
			end
		end
		--print("update start");
		if self:IsActivated() then
			self.acti = true;
			for i = 1, 6 do
				Effect = CreateMOPixel("Air Blast", "Base.rte");
				if Effect then
					Effect.Vel = self.Vel + self:RotateOffset(Vector(10 + math.random() * 20,0)):DegRotate(-15 + math.random()*30);
					Effect.Pos = self.Pos;
					--Effect:SetWhichMOToNotHit(self, 0.1);
					Effect.Team = self.alliedTeam;
					Effect.IgnoresTeamHits = true;
					MovableMan:AddParticle(Effect);
				end
			end
		elseif self.acti then
			local cood = Vector(0,0);
			if SceneMan:CastNotMaterialRay(self.Pos, self:RotateOffset(Vector(45,0)), 0, cood, 5, false) == false then
				for i = 1, 3, 1 do
					local missile = CreateMOPixel("Grenade Fragment Yellow", "AAA.rte");
					if missile then
						missile.Team = self.alliedTeam;
						missile.IgnoresTeamHits = true;
						missile.Pos = self.Pos + self:RotateOffset(Vector(45,0));
						missile.Vel = Vector(15 + math.random() * 10,0):RadRotate(math.random()*2*math.pi);
						MovableMan:AddParticle(missile);
					end
				end
				for i = 1, 10, 1 do
					local missile = CreateMOPixel("Main Thruster Blast Spark");
					if missile then
						missile.Team = self.alliedTeam;
						missile.IgnoresTeamHits = true;
						missile.Pos = self.Pos + self:RotateOffset(Vector(45,0));
						missile.Vel = Vector(9,0):RadRotate(math.random()*2*math.pi);
						MovableMan:AddParticle(missile);
					end
				end
				for i = 1, 20, 1 do
					local missile = CreateMOSParticle("Side Thruster Blast Ball 1");
					if missile then
						missile.Team = self.alliedTeam;
						missile.IgnoresTeamHits = true;
						missile.Pos = self.Pos + self:RotateOffset(Vector(45,0));
						missile.Vel = Vector(2 + math.random() * 10,0):RadRotate(math.random()*2*math.pi);
						MovableMan:AddParticle(missile);
					end
				end
				for i = 1, 8, 1 do
					local missile = CreateMOSParticle("Fire Puff Medium");
					if missile then
						missile.Team = self.alliedTeam;
						missile.IgnoresTeamHits = true;
						missile.Pos = self.Pos + self:RotateOffset(Vector(45,0));
						missile.Vel = Vector(1 + math.random() * 3,0):RadRotate(math.random()*2*math.pi);
						MovableMan:AddParticle(missile);
					end
				end
			end
			self.acti = false;
		end
		--print("b4 rooted");
		if self.WoundCount > self.limit then
			self.limit = self.WoundCount;
			for i = 1, 360 do
				local missile = CreateMOPixel("Water Jet", "AAA.rte");
				missile.Team = self.alliedTeam;
				missile.IgnoresTeamHits = true;
				missile.Pos = self.Pos; --actor.EquippedItem.Pos;
				missile.Vel = self.Vel + self:RotateOffset(Vector(50 + math.random() * 10,0)):DegRotate(-45 + math.random()*90);
				MovableMan:AddParticle(missile);
			end
			--[[
			local flicker = CreateAEmitter("AAA.rte/Flyfrost");
			print(flicker);
			if flicker then
				flicker.Pos = self.Pos;
				flicker.Team = self.alliedTeam;
				--flicker.Sharpness = actor.ID;
				MovableMan:AddParticle(flicker);
			end
			]]
		end
	else
		--print("rename");
		if self.PresetName ~= "Elemental Grimoire" then
			self.PresetName = "Elemental Grimoire";
		end
		if self.SharpLength ~= 0 then
			self.SharpLength = 0;
		end
	end


end

function Destroy(self)

	if self.ID ~= self.RootID then
		local actor = MovableMan:GetMOFromID(self.RootID);
		if MovableMan:IsActor(actor) then
			if actor ~= nil then
				local swarm = CreateAEmitter("Pebbleswarm", "AAA.rte");
				swarm.Pos = actor.Pos;
				swarm.Team = team;
				swarm.Sharpness = actor.RootID;
				MovableMan:AddParticle(swarm);
			end
		end
	end

end