function Create(self)
	self.Ammo = 3;
end

function Update(self)

	if self.Ammo > 0 then
		local target = Vector(0,0);
		if SceneMan:CastObstacleRay(self.Pos,Vector(self.Vel.Normalized.X*self.Vel.Magnitude,self.Vel.Normalized.Y*self.Vel.Magnitude),target,Vector(),self.ID,self.Team,0,0) >= 0 then
			for i = 1, self.Ammo, 1 do
				local missile = CreateMOPixel("Grenade Fragment Yellow", "AAA.rte");
				if missile then
					missile.Team = self.Team;
					missile.IgnoresTeamHits = true;
					missile.Pos = target - self.Vel.Normalized;
					missile.Vel = Vector(15 + math.random() * 10,0):RadRotate(math.random()*2*math.pi);
					MovableMan:AddParticle(missile);
				end
			end
			for i = 1, 10, 1 do
				local missile = CreateMOPixel("Main Thruster Blast Spark");
				if missile then
					missile.Team = self.Team;
					missile.IgnoresTeamHits = true;
					missile.Pos = target - self.Vel.Normalized;
					missile.Vel = Vector(9,0):RadRotate(math.random()*2*math.pi);
					MovableMan:AddParticle(missile);
				end
			end
			for i = 1, 20, 1 do
				local missile = CreateMOSParticle("Side Thruster Blast Ball 1");
				if missile then
					missile.Team = self.Team;
					missile.IgnoresTeamHits = true;
					missile.Pos = target - self.Vel.Normalized;
					missile.Vel = Vector(2 + math.random() * 10,0):RadRotate(math.random()*2*math.pi);
					MovableMan:AddParticle(missile);
				end
			end
			for i = 1, 8, 1 do
				local missile = CreateMOSParticle("Fire Puff Medium");
				if missile then
					missile.Team = self.Team;
					missile.IgnoresTeamHits = true;
					missile.Pos = target - self.Vel.Normalized;
					missile.Vel = Vector(1 + math.random() * 3,0):RadRotate(math.random()*2*math.pi);
					MovableMan:AddParticle(missile);
				end
			end
			self.Ammo = 0;
			--self:GibThis();
		end
	end
	
end

function Destroy(self)
--[[
	if self.Age > 50 then
		for i = 1, 3, 1 do
			local missile = CreateMOPixel("Grenade Fragment Yellow", "AAA.rte");
			if missile then
				missile.Team = self.Team;
				missile.IgnoresTeamHits = true;
				missile.Pos = self.Pos;
				missile.Vel = Vector(15 + math.random() * 10,0):RadRotate(math.random()*2*math.pi);
				MovableMan:AddParticle(missile);
			end
		end
	end]]
	
end