function Create(self)

	self.mapwrapx = SceneMan.SceneWrapsX;

	--self.maxlinelength = 400;
	self.setlinelength = 0;
	self.linelength = 0;
	self.linevec = Vector(0,0);
	
	self.gotid = self.Sharpness;
	--if IsMovableObject(MovableMan:GetMOFromID(self.gotid)) then
	self.owner = ToMovableObject(MovableMan:GetMOFromID(self.gotid));
	--print(self.owner);
	--else
	--	self.owner = nil;
	--end

	self.Sharpness = 0;
	self.PinStrength = 1000; --attach
	--self.Frame = 1;
	self.linevec = SceneMan:ShortestDistance(self.owner.Pos,self.Pos,self.mapwrapx);
	self.setlinelength = self.linevec.Magnitude;

end

function Update(self)

	if self.owner ~= nil and IsMOSRotating(self.owner) == true then

		self.ToDelete = false;
		self.ToSettle = false;

		self.linevec = SceneMan:ShortestDistance(self.owner.Pos,self.Pos,self.mapwrapx);
		self.linelength = self.linevec.Magnitude;

		FrameMan:DrawLinePrimitive(self.owner.Pos,self.Pos,3)
		
		if self.linelength > self.setlinelength then --line pull here

			local movetopos = self.Pos + (self.linevec*-1):SetMagnitude(self.setlinelength);
			if self.mapwrapx == true then
				if movetopos.X > SceneMan.SceneWidth then
					movetopos = Vector(movetopos.X - SceneMan.SceneWidth,movetopos.Y);
				elseif movetopos.X < 0 then
					movetopos = Vector(SceneMan.SceneWidth + movetopos.X,movetopos.Y);
				end
			end
			self.owner.Pos = movetopos;

			local pullamountnumber = math.abs(self.linevec.AbsRadAngle-self.owner.Vel.AbsRadAngle)/(math.pi*2);
			self.owner.Vel = self.owner.Vel + self.linevec:SetMagnitude(self.owner.Vel.Magnitude*pullamountnumber);

		end

	else --no gun/no owner etc
		self.ToDelete = true;
	end

end

function Destroy(self)

end