function Create(self)
--[[
	for i = 1, 3, 1 do
		local missile = CreateMOPixel("Ice Particle Sharp", "AAA.rte");
		missile.Team = self.Team;
		missile.IgnoresTeamHits = true;
		missile.Pos = self.Pos;
		missile.Vel = self.Vel;
		MovableMan:AddParticle(missile);
	end]]
	self.Ammo = 3;
end

function Update(self)

	local smoke = CreateMOSParticle("Tiny Smoke Ball 1"); -- dem smoke trails for the pretties
	smoke.Pos = self.Pos;
	smoke.Lifetime = smoke.Lifetime/((math.random(100,200)/100)); -- random looks like that because it only picks whole numbers
	MovableMan:AddMO(smoke);
	if self.Ammo > 0 then
		if SceneMan:CastObstacleRay(self.Pos,Vector(self.Vel.Normalized.X*self.Vel.Magnitude,self.Vel.Normalized.Y*self.Vel.Magnitude),Vector(),Vector(),self.ID,self.Team,0,0) >= 0 then
			for i = 1, self.Ammo, 1 do
				local missile = CreateMOPixel("Ice Particle Sharp", "AAA.rte");
				missile.Team = self.Team;
				missile.IgnoresTeamHits = true;
				missile.Pos = self.Pos;
				missile.Vel = self.Vel;
				MovableMan:AddParticle(missile);
			end
			self.Ammo = 0;
		end
		if math.random(1,5) == 5 then
			for actor in MovableMan.Actors do
				if IsAHuman(actor) or IsACrab(actor) then
					if actor.Team ~= self.Team then
						if SceneMan:ShortestDistance(self.Pos, actor.Pos, true).Magnitude < 30 then
							local Effect = CreateAEmitter("SlowCount", "AAA.rte");
							Effect.Pos = actor.Pos;
							--Effect:SetWhichMOToNotHit(actor, 0.1)
							Effect.Team = self.Team;
							Effect.Sharpness = actor.RootID;
							Effect.IgnoresTeamHits = true;
							--Add the particle to the world.
							MovableMan:AddParticle(Effect);
						end
					end
				end
			end
		end
	end

end

function Destroy(self)

end