dofile("AAA.rte/SpellFunctions.lua")

function MageOption(self)

	--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--
	--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	
	self.naming = 1;
	--DETERMINE IF SPELL NAMES WILL SHOW IN PIE MENU (0 - NONE, 1 - RENAME EQUIPPED ITEM, 2 - RENAME NEW ITEM), SET 0 FOR VOID WANDERER OR SPELLBOOK WILL NOT TELEPORT OVER.
	self.hotkeys = true;
	--DETERMINE IF KEYBOARD NUMBER 1 to 0 can choose spells for you.
	self.booklearn = false;
	--DETERMINE IF SPELLBOOKS CAN TEACH SPELLS TO CASTERS WHO ONE HAVE ONE SPELL, SET TRUE FOR VOID WANDERER OR YOU ONLY GET BASIC SPELL, BUT YOU MIGHT LIKE IT EVEN IF NOT USING VOID WANDERER.
	self.switchpersec = 0.3;
	--DETERMINE CHANCE OF AI SWITCHING SPELLS PER SECOND OF CASTING TIME, HIGHER FOR MORE VARIETY, LOWER FOR MORE CONSISTANCY.
	
	--[[
	Key 	Number
	A 	1
	B 	2
	C 	3
	D 	4
	E 	5
	F 	6
	G 	7
	H 	8
	I 	9
	J 	10
	K 	11
	L 	12
	M 	13
	N 	14
	O 	15
	P 	16
	Q 	17
	R 	18
	S 	19
	T 	20
	U 	21
	V 	22
	W 	23
	X 	24
	Y 	25
	Z 	26
	0 	27
	1 	28
	2 	29
	3 	30
	4 	31
	5 	32
	6 	33
	7 	34
	8 	35
	9 	36
	Numpad 0 	37
	Numpad 1 	38
	Numpad 2 	39
	Numpad 3 	40
	Numpad 4 	41
	Numpad 5 	42
	Numpad 6 	43
	Numpad 7 	44
	Numpad 8 	45
	Numpad 9 	46
	Backspace 	63
	Tab 	64
	Enter 	67
	Less than(<) / Greater than(>) 	71
	Spacebar 	75
	Insert 	76
	Delete 	77
	Pos1 	78
	End 	79
	Page up 	80
	Page down 	81
	Arrow Left 	82
	Arrow Right 	83
	Arrow Up 	84
	Arrow Down 	85 
]]
	--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--OPTIONS--
	--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	--VOID WANDERER => FORCE SETTINGS
	local act = ActivityMan:GetActivity();

	--if act.Description == "Oh my God it's full of stars." then
	if act.PresetName == "Void Wanderers" then
		self.naming = 0;
		self.booklearn = true;
	end
	
end

function SpellSwitch(self, choice)

	self.charged = false;
	self.chargeTimer:Reset();

	self.spellchoice = choice;--(self.spellchoice + 1) % self.spellnumber;
	self.spell = self.spelltable[self.spellchoice];
	self.spellelement = ElementGet(self.spell);
	self.spellname, self.spellcost, self.spellcast, self.spellrange, self.spellmode = SpellGet(self.spell);
	self.spellcost = math.ceil(self.spellcost * ToActor(self):GetNumberValue("Efficiency"));
	self.spellcast = math.ceil(self.spellcast * ToActor(self):GetNumberValue("Spell Speed"));
	if self.element == 1 and self.spellelement == 1 then
		self.spellcast = math.ceil(self.spellcast * 0.7);
	end

	self.spellemblem = EmblemGet(self.spell);
	self.spellcolor = ColorGet(self.spellelement);
	
end

function MageInit(self)

	--KILL MAGE IF UNLOADED FROM CARFT SECOND TIME(MAGICAL INTERACTION W TECH ON FIELD W O WARDING)
	if self.Sharpness == 1 then
		self.Sharpness = 0;
	else
		self.Health = -4444;
		self.Sharpness = 4;
		--self:GibThis();
	end

	MageOption(self);

	if ToActor(self):NumberValueExists("Bonus Mana") == false then
		ToActor(self):SetNumberValue("Bonus Mana", 0);
	end
	
	if ToActor(self):NumberValueExists("Spell1") then
		for i = 1, ToActor(self):GetNumberValue("Spell Max"), 1 do
			if ToActor(self):NumberValueExists("Spell" .. i) then
				self.spelltable[i] = ToActor(self):GetNumberValue("Spell" .. i);
				ToActor(self):RemoveNumberValue("Spell" .. i);
				self.spellnumber = i;
			end
		end
	end

	self.core = 0;
	--self.init = 0;
	if self.EquippedItem ~= nil and self.EquippedItem.ClassName == "HDFirearm" and  ToHDFirearm(self.EquippedItem).Magazine ~= nil then
		--print("A");
		if ToHDFirearm(self.EquippedItem).Magazine.PresetName == "Scrollcore" then
			--print("B");
			if self:EquipDeviceInGroup("Spellbooks",true) == false then
				--print("C");
				if self:EquipDeviceInGroup("Spelltools",true) == false then
					--print("D");
					--local playa = ToActor(self):GetController().Player;
					--print(playa);
					local Activ = ActivityMan:GetActivity();
					--print(Activ);
					--print(Activ:PlayerActive(playa));
					if Activ:PlayersInTeamCount(self.Team) <= 0 then
						--print("E");
						local item = CreateHDFirearm("Bound Tome");
						item.GoldValue = 0;
						self:AddInventoryItem(item);
						self:EquipDeviceInGroup("Spellbooks",true);
					end
				end
			end
		end
	end
	--print("F");
	
	self.spelltarget = Vector(0,0);
	self.prevspelltarget = Vector(0,0);
	self.regenTimer = Timer();
	self.runeTimer = Timer();
	self.chargeTimer = Timer();

	self.selected = false;
	
	SpellSwitch(self, self.spellchoice);
	--[[
	self.charged = false;
	self.chargeTimer:Reset();
	
	--self.spellchoice = math.random(0, self.spellnumber - 1);
	
	self.spell = self.spelltable[self.spellchoice];
	self.spellelement = ElementGet(self.spell);
	self.spellname, self.spellcost, self.spellcast, self.spellrange, self.spellmode = SpellGet(self.spell);
	self.spellcost = math.ceil(self.spellcost * ToActor(self):GetNumberValue("Efficiency"));
	self.spellcast = math.ceil(self.spellcast * ToActor(self):GetNumberValue("Spell Speed"));
	if (self.element == 1) and (self.spellelement == 1) then
		self.spellcast = math.ceil(self.spellcast * 0.7);
	end
	--self.spellrange = self.spellrange * self.spellreach;
	--if self.element ~= self.spellelement then
	--	self.spellcost = math.ceil(self.spellcost * ToActor(self):GetNumberValue("Obstinacy"));
	--	self.spellcast = math.ceil(self.spellcast * ToActor(self):GetNumberValue("Obstinacy"));
	--end
	self.spellemblem = EmblemGet(self.spell);
	self.spellcolor = ColorGet(self.spellelement);
	]]

end

function MageStep(self)
--[[
 __allegro_KEY_0 = 27,
__allegro_KEY_1 = 28,
__allegro_KEY_2 = 29,
__allegro_KEY_3 = 30,
__allegro_KEY_4 = 31,
__allegro_KEY_5 = 32,
__allegro_KEY_6 = 33,
__allegro_KEY_7 = 34,
__allegro_KEY_8 = 35,
__allegro_KEY_9 = 36, 


]]
--print(KEY_0);
--unpickupable item, hover at back for tooltip

--KEY_0
--print("LOG");
--print(UInputMan:WhichJoyButtonPressed(0));



	self.core = 0;
	if self.EquippedItem ~= nil and self.EquippedItem.ClassName == "HDFirearm" and  ToHDFirearm(self.EquippedItem).Magazine ~= nil then
		if ToHDFirearm(self.EquippedItem).Magazine.PresetName == "Spellcore" then
			self.core = 1;
		elseif ToHDFirearm(self.EquippedItem).Magazine.PresetName == "Trapcore" then --spelltrap, landmines, etch
			self.core = 2;
		elseif ToHDFirearm(self.EquippedItem).Magazine.PresetName == "Potioncore" then --potion, grenade, infuse
			self.core = 3;
		elseif ToHDFirearm(self.EquippedItem).Magazine.PresetName == "Rollcore" then --rollerbomb, rollerbomb, engrave
			self.core = 4;
		elseif ToHDFirearm(self.EquippedItem).Magazine.PresetName == "Bombcore" then --zombie, actor, bind
			self.core = 5;
		--elseif ToHDFirearm(self.EquippedItem).Magazine.PresetName == "Magecore" then --skele, mage, confer
		--	self.core = 6;
		--elseif ToHDFirearm(self.EquippedItem).Magazine.PresetName == "Weaponcore" then --staff, gun, enchant
		--	self.core = 7;
		--elseif ToHDFirearm(self.EquippedItem).Magazine.PresetName == "Scrollcore" then --scroll, item
		--	self.core = -1;
		end
	end

		--mana regen and actor specific effects--
	if (self.charged == false) and (self.core > 0 and ToHDFirearm(self.EquippedItem):IsActivated() == false) or ToActor(self):GetNumberValue("Mana") < self.spellcost then
		self.chargeTimer:Reset();
		--self.charged = false;
		if self.regenTimer:IsPastSimMS(1000) then
			self.regenTimer:Reset();
			ToActor(self):SetNumberValue("Mana", math.min(ToActor(self):GetNumberValue("Max Mana"), ToActor(self):GetNumberValue("Mana") + ToActor(self):GetNumberValue("Mana Regen")));
			if (self.element == 6) then
				if ToActor(self).Health > 70 then
					ToActor(self).Health = ToActor(self).Health - 1;
					ToActor(self):SetNumberValue("Mana", math.min(ToActor(self):GetNumberValue("Max Mana"), ToActor(self):GetNumberValue("Mana") + ToActor(self):GetNumberValue("Mana Regen")));
				end
			elseif (self.element == 3) then
				if ToActor(self).Health <= 70 then
					ToActor(self):SetNumberValue("Mana", math.min(ToActor(self):GetNumberValue("Max Mana"), ToActor(self):GetNumberValue("Mana") + 2));
				end
			elseif (self.element == 2) and (self.spellelement == 2) then
				if ToActor(self).Health < (100 - self.WoundCount) then
					self.Health = math.min(self.Health + 3, 100 - self.WoundCount)
					local Cross = CreateMOSParticle("Particle Heal Effect", "Base.rte")
					if Cross then
						Cross.Pos = self.AboveHUDPos + Vector(0, 4)	-- Set the particle's position to just over the actor's head
						MovableMan:AddParticle(Cross)
					end
				end
			elseif (self.element == 4) and (self.spellelement == 4) then
				ToActor(self):SetNumberValue("Mana", math.min(ToActor(self):GetNumberValue("Max Mana"), ToActor(self):GetNumberValue("Mana") + 5));
			end
			ToActor(self):SetNumberValue("Mana", math.min(ToActor(self):GetNumberValue("Max Mana"), ToActor(self):GetNumberValue("Mana") + ToActor(self):GetNumberValue("Bonus Mana")));
			ToActor(self):SetNumberValue("Bonus Mana", 0);
		end
	end
		
	if self.core > 0 then
		--void wanderer spellbook learning
		if self.booklearn == true then
			if self.spellnumber == 1 and self.core == 1 then		
				--local Activ = ActivityMan:GetActivity();
				--if Activ:PlayersInTeamCount(self.Team) > 0 then
				local newspell = 0;
				local add = false;
				if ToHDFirearm(self.EquippedItem).PresetName == "Basic Spellbook" then
					while self.spellnumber < 4 do
						newspell = (self.element * 10) + math.random(0,3);
						add = true;
						--go though all your spells for repeats
						for j = 1, self.spellnumber do
							if self.spelltable[j] == newspell then
								add = false;
								break;
							end
						end
						if add == false then
							newspell = (math.random(1,5) * 10) + math.random(0,2);
							add = true;
							--go though all your spells for repeats
							for j = 1, self.spellnumber do
								if self.spelltable[j] == newspell then
									add = false;
									break;
								end
							end
						end
						if add == true then
							self.spellnumber = self.spellnumber + 1;
							self.spelltable[self.spellnumber] = newspell;
						end
					end
				elseif ToHDFirearm(self.EquippedItem).PresetName == "Elemental Grimoire" then
					local newspell = 0;
					local add = false;
					while self.spellnumber < 6 do
						newspell = (self.element * 10) + math.random(0,4);
						add = true;
						--go though all your spells for repeats
						for j = 1, self.spellnumber do
							if self.spelltable[j] == newspell then
								add = false;
								break;
							end
						end
						if add == false then
							newspell = (math.random(1,4) * 10) + math.random(0,4);
							add = true;
							--go though all your spells for repeats
							for j = 1, self.spellnumber do
								if self.spelltable[j] == newspell then
									add = false;
									break;
								end
							end
						end
						if add == true then
							self.spellnumber = self.spellnumber + 1;
							self.spelltable[self.spellnumber] = newspell;
						end
					end
				elseif ToHDFirearm(self.EquippedItem).PresetName == "Necronomicon" then
					local newspell = 0;
					local add = false;
					while self.spellnumber < 9 do
						newspell = (self.element * 10) + math.random(0,5);
						add = true;
						--go though all your spells for repeats
						for j = 1, self.spellnumber do
							if self.spelltable[j] == newspell then
								add = false;
								break;
							end
						end
						if add == false then
							newspell = (math.random(4,6) * 10) + math.random(0,5);
							add = true;
							--go though all your spells for repeats
							for j = 1, self.spellnumber do
								if self.spelltable[j] == newspell then
									add = false;
									break;
								end
							end
						end
						if add == true then
							self.spellnumber = self.spellnumber + 1;
							self.spelltable[self.spellnumber] = newspell;
						end
					end
				elseif ToHDFirearm(self.EquippedItem).PresetName == "Spell Sword" then
					local newspell = 0;
					local add = false;
					while self.spellnumber < 7 do
						newspell = (self.element * 10) + math.random(0,5);
						add = true;
						--go though all your spells for repeats
						for j = 1, self.spellnumber do
							if self.spelltable[j] == newspell then
								add = false;
								break;
							end
						end
						if add == false then
							newspell = (math.random(1,6) * 10) + math.random(0,4);
							add = true;
							--go though all your spells for repeats
							for j = 1, self.spellnumber do
								if self.spelltable[j] == newspell then
									add = false;
									break;
								end
							end
						end
						if add == true then
							self.spellnumber = self.spellnumber + 1;
							self.spelltable[self.spellnumber] = newspell;
						end
					end
				end
				--Switch spells if you learn any spell, for AI and convenience
				if self.spellnumber > 1 then
					SpellSwitch(self, math.random(1, self.spellnumber));
					--[[
					self.chargeTimer:Reset();
					self.charged = false;
					self.spellchoice = math.random(0, self.spellnumber - 1);
					self.spell = self.spelltable[self.spellchoice];
					self.spellelement = ElementGet(self.spell);
					self.spellname, self.spellcost, self.spellcast, self.spellrange, self.spellmode = SpellGet(self.spell);
					self.spellcost = math.ceil(self.spellcost * ToActor(self):GetNumberValue("Efficiency"));
					self.spellcast = math.ceil(self.spellcast * ToActor(self):GetNumberValue("Spell Speed"));
					if self.element == 1 and self.spellelement == 1 then
						self.spellcast = math.ceil(self.spellcast * 0.7);
					end
					--self.spellrange = self.spellrange * self.spellreach;	
					--if self.element ~= self.spellelement then
					--	self.spellcost = math.ceil(self.spellcost * ToActor(self):GetNumberValue("Obstinacy"));
					--	self.spellcast = math.ceil(self.spellcast * ToActor(self):GetNumberValue("Obstinacy"));
					--end
					self.spellemblem = EmblemGet(self.spell);
					self.spellcolor = ColorGet(self.spellelement);
					]]
				end
				--end
			end
		end
		--void wanderer spellbook learning END
	
		--spell learning
		if self.spellnumber < ToActor(self):GetNumberValue("Spell Max") and self:EquipDeviceInGroup("Scrolls",false) == true then
			for i = 1, 70 do
				local name = SpellGet(i);
				--print(name);
				if self:EquipNamedDevice(name .. " Scroll",false) and self.spellnumber < ToActor(self):GetNumberValue("Spell Max") then
				
					self:RemoveInventoryItem(name .. " Scroll");
					local add = true;
					--go though all your spells for repeats
					for j = 1, self.spellnumber do
						if self.spelltable[j] == i then
							add = false;
							break;
						end
					end
					if add == true then
						self.spellnumber = self.spellnumber + 1;
						self.spelltable[self.spellnumber] = i;
						--Switch spells if this is the first spell you learn, for AI and convenience
						--if self.spellnumber == 2 then
							
							--[[
							self.chargeTimer:Reset();
							self.charged = false;
							self.spellchoice = (self.spellchoice + 1) % self.spellnumber;
							self.spell = self.spelltable[self.spellchoice];
							self.spellelement = ElementGet(self.spell);
							self.spellname, self.spellcost, self.spellcast, self.spellrange, self.spellmode = SpellGet(self.spell);
							self.spellcost = math.ceil(self.spellcost * ToActor(self):GetNumberValue("Efficiency"));
							self.spellcast = math.ceil(self.spellcast * ToActor(self):GetNumberValue("Spell Speed"));
							if self.element == 1 and self.spellelement == 1 then
								self.spellcast = math.ceil(self.spellcast * 0.7);
							end
							--self.spellrange = self.spellrange * self.spellreach;	
							--if self.element ~= self.spellelement then
							--	self.spellcost = math.ceil(self.spellcost * ToActor(self):GetNumberValue("Obstinacy"));
							--	self.spellcast = math.ceil(self.spellcast * ToActor(self):GetNumberValue("Obstinacy"));
							--end
							self.spellemblem = EmblemGet(self.spell);
							self.spellcolor = ColorGet(self.spellelement);
							]]
						--end
					else
						local item = CreateHDFirearm(name .. " Scroll", "AAA.rte");
						item.Pos = self.Pos;
						MovableMan:AddItem(item);
					end
				end
			end
			--Switch spells if you learn any spells, for AI and convenience
			SpellSwitch(self, math.random(1, self.spellnumber));
		end
		
		--Sight-range
		if self.core == 1 then
			if (self.element == 5) and (self.spellmode >= 3) then
				ToHDFirearm(self.EquippedItem).SharpLength = math.floor(self.spellrange * 1.25);
			else
				ToHDFirearm(self.EquippedItem).SharpLength = self.spellrange;
			end
		end
		
		--flight
		--[[
		if self:NumberValueExists("Lev") then
			if self:GetController():IsState(Controller.HOLD_LEFT) then
				self:AddImpulseForce(Vector(-20,0),Vector(0,0))
			elseif self:GetController():IsState(Controller.HOLD_RIGHT) then
				self:AddImpulseForce(Vector(20,0),Vector(0,0))
			else
				self.Vel.X = self.Vel.X * 0.7;
			end
			if self:GetController():IsState(Controller.BODY_JUMP) then
				self:AddImpulseForce(Vector(0,-20),Vector(0,0))
			elseif self:GetController():IsState(Controller.BODY_CROUCH) then
				self:AddImpulseForce(Vector(0,20),Vector(0,0))
			else
				self.Vel.Y = self.Vel.Y * 0.7;
			end
			self.JetTimeLeft = 0;
			self.RotAngle = self.RotAngle * 0.7;
			--print(self.RotAngle);
			self.Vel = self.Vel - (SceneMan.GlobalAcc * TimerMan.DeltaTimeSecs);
		end
		]]
		local wheelr = 26;
		--Spell choice / emblem
		if ToActor(self):GetNumberValue("Mana") < self.spellcost then
			local oompos = self.Pos + Vector(0, -60);
			if self:IsPlayerControlled() and self:GetController():IsState(Controller.PIE_MENU_ACTIVE)  then
				oompos = self.Pos + Vector(0, -56);
			end
			FrameMan:DrawBoxFillPrimitive(oompos + Vector(-22, 3), oompos + Vector(22, -3), 245)
			local emblem = CreateMOSParticle("OOM Emblem Glow");
			--local emblem = CreateMOSParticle(self.spellemblem);
			emblem.Pos = oompos;
			emblem.Vel = self.Vel;
			--emblem.Vel = Vector(0,0);
			MovableMan:AddParticle(emblem);
		end
		--HOTKEYS
		if self.hotkeys then
			if self:IsPlayerControlled() then-- and UInputMan:AnyPress() then(Uncommenting may break gamepad dpad hotkeys)
				if (UInputMan:KeyPressed(64) or UInputMan:JoyButtonPressed(0,1)) and self.selected == false then
					SpellSwitch(self, (self.spellchoice % self.spellnumber) + 1);
					self.selected = true;
					PlaySound("Spell Select Sound Emitter",self.Pos);
				elseif UInputMan:KeyPressed(28) or UInputMan:JoyButtonPressed(0,0) then -- UInputMan:JoyButtonPressed(0,0) then
					if self.spellnumber >= 1 and self.spellchoice ~= 1 then 
						SpellSwitch(self, 1);
						PlaySound("Spell Select Sound Emitter",self.Pos);
					end
					--print("KEY_1");
				elseif UInputMan:KeyPressed(29) or UInputMan:JoyButtonPressed(0,2)  then -- UInputMan:JoyButtonPressed(0,1) then
					if self.spellnumber >= 2 and self.spellchoice ~= 2 then 
						SpellSwitch(self, 2);
						PlaySound("Spell Select Sound Emitter",self.Pos);
					end
					--print("KEY_2");
				elseif UInputMan:KeyPressed(30) or UInputMan:JoyButtonPressed(0,3)  then -- UInputMan:JoyButtonPressed(0,2) then
					if self.spellnumber >= 3 and self.spellchoice ~= 3 then 
						SpellSwitch(self, 3);
						PlaySound("Spell Select Sound Emitter",self.Pos);
					end
					--print("KEY_3");
				elseif UInputMan:KeyPressed(31) then -- UInputMan:JoyButtonPressed(0,3) then
					if self.spellnumber >= 4 and self.spellchoice ~= 4 then 
						SpellSwitch(self, 4);
						PlaySound("Spell Select Sound Emitter",self.Pos);
					end
					--print("KEY_4");
				elseif UInputMan:KeyPressed(32) then -- UInputMan:JoyDirectionPressed(0,2,1,0) then
					if self.spellnumber >= 5 and self.spellchoice ~= 5 then 
						SpellSwitch(self, 5);
						PlaySound("Spell Select Sound Emitter",self.Pos);
					end
					--print("KEY_5");
				elseif UInputMan:KeyPressed(33) then -- UInputMan:JoyDirectionPressed(0,2,0,1) then
					if self.spellnumber >= 6 and self.spellchoice ~= 6 then 
						SpellSwitch(self, 6);
						PlaySound("Spell Select Sound Emitter",self.Pos);
					end
					--print("KEY_6");
				elseif UInputMan:KeyPressed(34) then -- UInputMan:JoyDirectionPressed(0,2,1,1) then
					if self.spellnumber >= 7 and self.spellchoice ~= 7 then 
						SpellSwitch(self, 7);
						PlaySound("Spell Select Sound Emitter",self.Pos);
					end
					--print("KEY_7");
				elseif UInputMan:KeyPressed(35) then --or UInputMan:JoyDirectionPressed(0,2,0,0) then
					if self.spellnumber >= 8 and self.spellchoice ~= 8 then 
						SpellSwitch(self, 8);
						PlaySound("Spell Select Sound Emitter",self.Pos);
					end
					--print("KEY_8");
				elseif UInputMan:KeyPressed(36) then
					if self.spellnumber >= 9 and self.spellchoice ~= 9 then 
						SpellSwitch(self, 9);
						PlaySound("Spell Select Sound Emitter",self.Pos);
					end
					--print("KEY_9");
				elseif UInputMan:KeyPressed(27) then
					if self.spellnumber >= 10 and self.spellchoice ~= 10 then 
						SpellSwitch(self, 10);
						PlaySound("Spell Select Sound Emitter",self.Pos);
					end
					--print("KEY_0");
				end
			end
		end
		--PIEMENU
		if self:IsPlayerControlled() and self:GetController():IsState(Controller.PIE_MENU_ACTIVE)  then
			for i = 1, self.spellnumber do
				FrameMan:DrawCircleFillPrimitive(self.Pos + Vector(wheelr,0):DegRotate(90+(360/self.spellnumber)*(i-self.spellchoice)), 7, 245);
				local emblem = CreateMOSParticle(EmblemGet(self.spelltable[i]) .. " Glow");
				--local emblem = CreateMOSParticle(EmblemGet(self.spelltable[i]));
				emblem.Pos = self.Pos + Vector(wheelr,0):DegRotate(90+(360/self.spellnumber)*(i-self.spellchoice));
				emblem.Vel = self.Vel;
				--emblem.Vel = Vector(0,0);
				MovableMan:AddParticle(emblem);
			end
			if self:GetController():IsState(Controller.PRIMARY_ACTION) and self.selected == false then
				--[[
				self.chargeTimer:Reset();
				self.charged = false;
				self.spellchoice = (self.spellchoice + 1) % self.spellnumber;
				self.spell = self.spelltable[self.spellchoice];
				self.spellelement = ElementGet(self.spell);
				self.spellname, self.spellcost, self.spellcast, self.spellrange, self.spellmode = SpellGet(self.spell);
				self.spellcost = math.ceil(self.spellcost * ToActor(self):GetNumberValue("Efficiency"));
				self.spellcast = math.ceil(self.spellcast * ToActor(self):GetNumberValue("Spell Speed"));
				if self.element == 1 and self.spellelement == 1 then
					self.spellcast = math.ceil(self.spellcast * 0.7);
				end
				--self.spellrange = self.spellrange * self.spellreach;	
				--if self.element ~= self.spellelement then
				--	self.spellcost = math.ceil(self.spellcost * ToActor(self):GetNumberValue("Obstinacy"));
				--	self.spellcast = math.ceil(self.spellcast * ToActor(self):GetNumberValue("Obstinacy"));
				--end
				self.spellemblem = EmblemGet(self.spell);
				self.spellcolor = ColorGet(self.spellelement);
				]]
				SpellSwitch(self, (self.spellchoice % self.spellnumber) + 1);
				self.selected = true;
				PlaySound("Spell Select Sound Emitter",self.Pos);
			end
			
			if self.naming == 1 then
				if self.core == 1 then
					self.EquippedItem.PresetName = self.spellname; -- spell naming
				elseif self.core == 2 then
					self.EquippedItem.PresetName = "Etch " .. self.spellname;
				elseif self.core == 3 then
					self.EquippedItem.PresetName = "Infuse " .. self.spellname;
				elseif self.core == 4 then
					self.EquippedItem.PresetName = "Engrave " .. self.spellname;
				elseif self.core == 5 then
					self.EquippedItem.PresetName = "Bind " .. self.spellname;
			--	elseif self.core == 6 then
			--		self.EquippedItem.PresetName = "Confer " .. self.spellname;
			--	elseif self.core == 7 then
			--		self.EquippedItem.PresetName = "Enchant " .. self.spellname;
				end
			elseif self.naming == 2 then
				local item = CreateHDFirearm("Tooltip Item", "AAA.rte");
				if self.core == 1 then
					item.PresetName = self.spellname;
				elseif self.core == 2 then
					item.PresetName = "Etch " .. self.spellname;
				elseif self.core == 3 then
					item.PresetName = "Infuse " .. self.spellname;
				elseif self.core == 4 then
					item.PresetName = "Engrave " .. self.spellname;
				elseif self.core == 5 then
					item.PresetName = "Bind " .. self.spellname;
			--	elseif self.core == 6 then
			--		item.PresetName = "Confer " .. self.spellname;
			--	elseif self.core == 7 then
			--		item.PresetName = "Enchant " .. self.spellname;
				end
				item.Pos = self.Pos + Vector(0, -34);
				item.Vel = self.Vel;
				MovableMan:AddParticle(item);
			end
			
			if self.spellcost > 0 then
				ToHDFirearm(self.EquippedItem).Magazine.RoundCount = self.spellcost; --crash when fired with roundcount = 0
			else
				ToHDFirearm(self.EquippedItem).Magazine.RoundCount = -1;
			end
		else
			FrameMan:DrawCircleFillPrimitive(self.Pos + Vector(wheelr,0):DegRotate(90), 7, 245)
			local emblem = CreateMOSParticle(self.spellemblem .. " Glow");
			--local emblem = CreateMOSParticle(self.spellemblem);
			emblem.Pos = self.Pos + Vector(wheelr,0):DegRotate(90);
			emblem.Vel = self.Vel;
			--emblem.Vel = Vector(0,0);
			MovableMan:AddParticle(emblem);
			
			if ToActor(self):GetNumberValue("Mana") > 0 then
				ToHDFirearm(self.EquippedItem).Magazine.RoundCount = ToActor(self):GetNumberValue("Mana"); --crash when fired with roundcount = 0
			else
				ToHDFirearm(self.EquippedItem):Reload();
			end
			--[[
			if (self.element == 6) and (self.spellelement == 6) then
				local VectorRel = Vector(self.spellrange,0):RadRotate(self:GetAimAngle(true));--:GetXFlipped(self.HFlipped))
				local dottarget = Vector(0,0);
				ray = SceneMan:CastObstacleRay(self.Pos, VectorRel, dottarget, Vector(0,0), self.RootID, self.Team, 0, 1);
				if ray >= 0 then
					local point = CreateMOSParticle("Tiny Purple Glow", "AAA.rte");
					point.Pos = dottarget;
					point.Vel = Vector(0,0);
					MovableMan:AddParticle(point);
				end
			end
			]]
			if ToActor(self):GetNumberValue("Mana") >= self.spellcost then
				if ToHDFirearm(self.EquippedItem):IsActivated() then
					if (self.element == 6) and (self.spellelement == 6) then
						local VectorRel = Vector(self.spellrange,0):RadRotate(self:GetAimAngle(true));--:GetXFlipped(self.HFlipped))
						local dottarget = Vector(0,0);
						ray = SceneMan:CastObstacleRay(self.Pos, VectorRel, dottarget, Vector(0,0), self.RootID, self.Team, 0, 1);
						if ray >= 0 then
							local point = CreateMOSParticle("Tiny Purple Glow", "AAA.rte");
							point.Pos = dottarget;
							point.Vel = Vector(0,0);
							MovableMan:AddParticle(point);
						end
					end
					if self.spellmode >= 3 and self.core == 1 then
						local VectorRel = Vector(self.spellrange,0):RadRotate(self:GetAimAngle(true));--:GetXFlipped(self.HFlipped))
						ray = SceneMan:CastObstacleRay(self.Pos, VectorRel, self.spelltarget, self.prevspelltarget, self.RootID, self.Team, 0, 1);
						if ray >= 0 then
							--Line Effect
							local point = CreateMOSParticle("Magic Rune" .. math.random(0,9) .. " Particle", "AAA.rte");
							point.Pos = self.Pos + Vector(math.random() * ray,0):RadRotate(self:GetAimAngle(true));
							point.Vel = Vector(0,0);
							MovableMan:AddParticle(point);
							if self.chargeTimer:IsPastSimMS(self.spellcast) then
								--local point = CreateMOPixel("Magic Aim Done Particle");
								--point.Pos = self.spelltarget;
								--MovableMan:AddParticle(point);
								if self.spellmode == 3 then
									--Cross effect
									local point = CreateMOSParticle("Magic Rune" .. math.random(0,9) .. " Particle", "AAA.rte");
									point.Pos = self.spelltarget + Vector(-20 + math.random() * 40,0);
									point.Vel = Vector(0,0);
									MovableMan:AddParticle(point);
									local point = CreateMOSParticle("Magic Rune" .. math.random(0,9) .. " Particle", "AAA.rte");
									point.Pos = self.spelltarget + Vector(0,-20 + math.random() * 40);
									point.Vel = Vector(0,0);
									MovableMan:AddParticle(point);
								elseif self.spellmode == 4 then
									local sel = MovableMan:GetClosestEnemyActor(self.Team, self.spelltarget, 35, Vector());
									if sel ~= nil then
										--Cross effect
										local point = CreateMOSParticle("Magic Rune" .. math.random(0,9) .. " Particle", "AAA.rte");
										point.Pos = sel.Pos + Vector(-20 + math.random() * 40,0);
										point.Vel = Vector(0,0);
										MovableMan:AddParticle(point);
										local point = CreateMOSParticle("Magic Rune" .. math.random(0,9) .. " Particle", "AAA.rte");
										point.Pos = sel.Pos + Vector(0,-20 + math.random() * 40);
										point.Vel = Vector(0,0);
										MovableMan:AddParticle(point);
									else
										ray = -1;
										--Dot effect
										local point = CreateMOSParticle("Magic Rune" .. math.random(0,9) .. " Particle", "AAA.rte");
										point.Pos = self.spelltarget;
										point.Vel = Vector(0,0);
										MovableMan:AddParticle(point);
									end
								end
							else
								--Circle Effect
								local frac = (self.spellcast - self.chargeTimer.ElapsedSimTimeMS)/ self.spellcast;
								local point = CreateMOSParticle("Magic Rune" .. math.random(0,9) .. " Particle", "AAA.rte");
								point.Pos = self.spelltarget + Vector(50 * frac,0):RadRotate(math.random() * 2 * math.pi);
								point.Vel = Vector(0,0);
								MovableMan:AddParticle(point);
							end
						end
					elseif self.spellmode ~= 1 or self.core ~= 1 then
						if self.chargeTimer:IsPastSimMS(self.spellcast) then

						else
							--Circle Effect
							local frac = (self.spellcast - self.chargeTimer.ElapsedSimTimeMS)/ self.spellcast;
							local point = CreateMOSParticle("Magic Rune" .. math.random(0,9) .. " Particle", "AAA.rte");
							point.Pos = self.EquippedItem.Pos + Vector(50 * frac,0):RadRotate(math.random() * 2 * math.pi);
							point.Vel = Vector(0,0);
							MovableMan:AddParticle(point);
						end
					end
					--self.charge = self.charge + 1;
					if self.chargeTimer:IsPastSimMS(self.spellcast) then
						if self.charged == false then
							--Charge Burst Effect
							self.charged = true;
							if self.spellmode ~= 1 or self.core ~= 1 then
								PlaySound("Spell Ready Sound Emitter",self.Pos);
								local explosion = CreateMOSRotating("Particle Arcane Explosion", "AAA.rte");
								explosion.Pos = self.EquippedItem.Pos + Vector(math.random() * 4,0):RadRotate(math.random() * 3.14);
								explosion.Vel = Vector(0,0);
								MovableMan:AddParticle(explosion);
								explosion:GibThis();
							end
						end
						--Hand Glow Effect
						local point = CreateMOSParticle(self.spellcolor, "AAA.rte");
						point.Pos = self.EquippedItem.Pos + Vector(math.random() * 4,0):RadRotate(math.random() * 3.14);
						point.Vel = Vector(0,-2);
						MovableMan:AddParticle(point);
					else
						if self.runeTimer:IsPastSimMS(100) then
							self.runeTimer:Reset();
							--Rune Speak Effect
							local point = CreateMOSParticle("Magic Rune" .. math.random(0,9) .. " Particle", "AAA.rte");
							point.Pos = self.CPUPos + Vector(math.random() * 8,0):RadRotate(math.random() * 3.14);
							point.Vel = Vector(0,-2);
							MovableMan:AddParticle(point);
						end
					end
				end
				if  (((self:IsPlayerControlled() == false or (self.spellmode == 1 and self.core == 1)) and ToHDFirearm(self.EquippedItem):IsActivated()) or (self:IsPlayerControlled() == true and ToHDFirearm(self.EquippedItem):IsActivated() == false)) and self.charged == true and (self.core ~= 1 or self.spellmode < 3 or ray >= 0) then
				--if  (((self:IsPlayerControlled() == false or self.spellmode == 1) and ToHDFirearm(self.EquippedItem):IsActivated()) or (self:IsPlayerControlled() == true and ToHDFirearm(self.EquippedItem):IsActivated() == false)) and self.charged == true and (self.core ~= 1 or self.spellmode ~= 3 or ray >= 0) then
					--print("REL");
					self.chargeTimer:Reset();
					self.charged = false;
					ToActor(self):SetNumberValue("Mana", ToActor(self):GetNumberValue("Mana") - self.spellcost);
					if self.core == 1 then
						SpellCast(self.spell, self, self.EquippedItem.Pos, self.spelltarget, self:GetAimAngle(true), self.Team);
						if (self.spellelement == self.element) and (math.random() <= self.twiceChance) then
							--local PlayedSound = CreateAEmitter("Dupe Sound Emitter");
							--PlayedSound.Pos = self.Pos;
							--MovableMan:AddParticle(PlayedSound);
							SpellCast(self.spell, self, self.EquippedItem.Pos, self.prevspelltarget, self:GetAimAngle(true), self.Team);
						end
						if (self.spellelement == self.element) and (math.random() <= self.freeChance) then
							--local PlayedSound = CreateAEmitter("Mana Sound Emitter");
							--PlayedSound.Pos = self.Pos;
							--MovableMan:AddParticle(PlayedSound);
							ToActor(self):SetNumberValue("Mana", math.min(ToActor(self):GetNumberValue("Max Mana"), ToActor(self):GetNumberValue("Mana") + math.floor(self.spellcost * 0.5)));
						end
						if (self.element == 6) and (self.spell == 60) then
							SpellCast(self.spell, self, self.EquippedItem.Pos, self.spelltarget, self:GetAimAngle(true), self.Team);
						end
						if self.spell == 2 then
							local PlayedSound = CreateAEmitter("LevelUp Sound Emitter");
							PlayedSound.Pos = self.Pos;
							MovableMan:AddParticle(PlayedSound);
							local summon = CreateAHuman(self.PresetName);
							summon.Team = self.Team;
							summon.Pos = self.Pos;
							summon.Vel = Vector(0,0);
							summon.AIMode = Actor.AIMODE_SENTRY;
							MovableMan:AddActor(summon); --mitosis
							summon:FlashWhite(200);
							ActivityMan:GetActivity():SwitchToActor(ToActor(summon),ToActor(self):GetController().Player,self.Team);
							ToActor(summon):SetNumberValue("Max Mana", ToActor(self):GetNumberValue("Max Mana"));
							ToActor(summon):SetNumberValue("Mana", ToActor(self):GetNumberValue("Max Mana"));
							ToActor(summon):SetNumberValue("Mana Regen", ToActor(self):GetNumberValue("Mana Regen"));
							ToActor(summon):SetNumberValue("Spell Speed", ToActor(self):GetNumberValue("Spell Speed"));
							ToActor(summon):SetNumberValue("Spell Max", ToActor(self):GetNumberValue("Spell Max"));
							ToActor(summon):SetNumberValue("Efficiency", ToActor(self):GetNumberValue("Efficiency"));
							ToActor(summon):SetNumberValue("Control", ToActor(self):GetNumberValue("Control"));
							for i = 1, self.spellnumber, 1 do
								ToActor(summon):SetNumberValue("Spell" .. i, self.spelltable[i]);
							end
							local item = CreateHDFirearm(self.EquippedItem.PresetName);
							--item.GoldValue = 0;
							summon:AddInventoryItem(item);
							--[[
							local egg = CreateACRocket("Soul Glyph", "AAA.rte");
							egg.Team = self.Team;
							egg.Pos = self.Pos;
							egg.Vel = Vector(0,0);
							MovableMan:AddParticle(egg);
							egg:AddInventoryItem(summon);
							]]
						elseif self.spell == 65 and self:NumberValueExists("Rebirth") == false then
							local PlayedSound = CreateAEmitter("LevelUp Sound Emitter");
							PlayedSound.Pos = self.Pos;
							MovableMan:AddParticle(PlayedSound);
							local summon = CreateAHuman(self.PresetName);
							summon.Team = self.Team;
							summon.Pos = self.Pos;
							summon.Vel = Vector(0,0);
							summon.AIMode = Actor.AIMODE_SENTRY;
							--MovableMan:AddActor(summon); --mitosis
							summon:FlashWhite(200);
							if math.random(1,2) == 2 then
								summon.HFlipped = true;
							end
							ActivityMan:GetActivity():SwitchToActor(ToActor(summon),ToActor(self):GetController().Player,self.Team);
							ToActor(summon):SetNumberValue("Max Mana", ToActor(self):GetNumberValue("Max Mana"));
							ToActor(summon):SetNumberValue("Mana", 0);
							ToActor(summon):SetNumberValue("Mana Regen", ToActor(self):GetNumberValue("Mana Regen"));
							ToActor(summon):SetNumberValue("Spell Speed", ToActor(self):GetNumberValue("Spell Speed"));
							ToActor(summon):SetNumberValue("Spell Max", ToActor(self):GetNumberValue("Spell Max"));
							ToActor(summon):SetNumberValue("Efficiency", ToActor(self):GetNumberValue("Efficiency"));
							ToActor(summon):SetNumberValue("Control", ToActor(self):GetNumberValue("Control"));
							for i = 1, self.spellnumber, 1 do
								ToActor(summon):SetNumberValue("Spell" .. i, self.spelltable[i]);
							end
							local item = CreateHDFirearm("Bound Tome");
							item.GoldValue = 0;
							summon:AddInventoryItem(item);
							local egg = CreateACRocket("Soul Glyph", "AAA.rte");
							egg.Team = self.Team;
							egg.Pos = self.Pos;
							egg.Vel = Vector(0,0);
							egg.Sharpness = self.RootID;
							MovableMan:AddParticle(egg);
							egg:AddInventoryItem(summon);
							ToActor(self):SetNumberValue("Control", ToActor(self):GetNumberValue("Control") - 1);
							--self:SetNumberValue("Rebirth", egg.ID);
						end
						--SPELL SWITCHING
						local Activ = ActivityMan:GetActivity();
						if Activ:PlayersInTeamCount(self.Team) <= 0 then
							if (math.random() * 1000) < (self.switchpersec * self.spellcast) then
								if self.spellnumber > 1 then
									--[[
									self.chargeTimer:Reset();
									self.charged = false;
									self.spellchoice = math.random(0, self.spellnumber - 1);
									self.spell = self.spelltable[self.spellchoice];
									self.spellelement = ElementGet(self.spell);
									self.spellname, self.spellcost, self.spellcast, self.spellrange, self.spellmode = SpellGet(self.spell);
									self.spellcost = math.ceil(self.spellcost * ToActor(self):GetNumberValue("Efficiency"));
									self.spellcast = math.ceil(self.spellcast * ToActor(self):GetNumberValue("Spell Speed"));
									if self.element == 1 and self.spellelement == 1 then
										self.spellcast = math.ceil(self.spellcast * 0.7);
									end
									--self.spellrange = self.spellrange * self.spellreach;	
									--if self.element ~= self.spellelement then
									--	self.spellcost = math.ceil(self.spellcost * ToActor(self):GetNumberValue("Obstinacy"));
									--	self.spellcast = math.ceil(self.spellcast * ToActor(self):GetNumberValue("Obstinacy"));
									--end
									self.spellemblem = EmblemGet(self.spell);
									self.spellcolor = ColorGet(self.spellelement);
									]]
									SpellSwitch(self, math.random(1, self.spellnumber));
								end
							end
						end
						--SPELL SWITCHING
					elseif self.core == 2 then
						local item = CreateTDExplosive("Etched Spell Trap", "AAA.rte");
						--print(item);
						item.PresetName = self.spellname .. " Trap";
						item.Sharpness = self.Team * 100 + self.spell;
						--print(item.Sharpness);
						self:AddInventoryItem(item);
						PlaySound("Wizard Trap Sound Emitter",self.Pos);
						--ToHDFirearm(self.EquippedItem):GibThis();
						local name = self.EquippedItem.PresetName;
						self:EquipNamedDevice(item.PresetName,true);
						self:RemoveInventoryItem(name);
						self.core = -1;
						--self:EquipThrowable(true);
						if math.random() <= self.dupeChance then
							--local PlayedSound = CreateAEmitter("Dupe Sound Emitter");
							--PlayedSound.Pos = self.Pos;
							--MovableMan:AddParticle(PlayedSound);
							local item = CreateTDExplosive("Etched Spell Trap", "AAA.rte");
							--print(item);
							item.PresetName = self.spellname .. " Trap";
							item.Sharpness = self.Team * 100 + self.spell;
							self:AddInventoryItem(item);
						end
					elseif self.core == 3 then
						local item = CreateTDExplosive("Splash Potion", "AAA.rte");
						--print(item);
						item.PresetName = self.spellname .. " Grenade";
						item.Sharpness = self.Team * 100 + self.spell;
						--print(item.Sharpness);
						self:AddInventoryItem(item);
						PlaySound("Potion Sound Emitter", self.Pos);
						--ToHDFirearm(self.EquippedItem):GibThis();
						local name = self.EquippedItem.PresetName;
						self:EquipNamedDevice(item.PresetName,true);
						self:RemoveInventoryItem(name);
						self.core = -1;
						--self:EquipThrowable(true);
						if math.random() <= self.dupeChance then
							--local PlayedSound = CreateAEmitter("Dupe Sound Emitter");
							--PlayedSound.Pos = self.Pos;
							--MovableMan:AddParticle(PlayedSound);
							local item = CreateTDExplosive("Splash Potion", "AAA.rte");
							--print(item);
							item.PresetName = self.spellname .. " Grenade";
							item.Sharpness = self.Team * 100 + self.spell;
							self:AddInventoryItem(item);
						end
					elseif self.core == 4 then
						local item = CreateTDExplosive("Armed Rollerbomb", "AAA.rte");
						--print(item);
						item.PresetName = self.spellname .. " Rollerbomb";
						item.Sharpness = self.Team * 100 + self.spell;
						--print(item.Sharpness);
						self:AddInventoryItem(item);
						PlaySound("Wizard Trap Sound Emitter", self.Pos);
						--ToHDFirearm(self.EquippedItem):GibThis();
						local name = self.EquippedItem.PresetName;
						self:EquipNamedDevice(item.PresetName,true);
						self:RemoveInventoryItem(name);
						self.core = -1;
						--self:EquipThrowable(true);
						if math.random() <= self.dupeChance then
							--local PlayedSound = CreateAEmitter("Dupe Sound Emitter");
							--PlayedSound.Pos = self.Pos;
							--MovableMan:AddParticle(PlayedSound);
							local item = CreateTDExplosive("Armed Rollerbomb", "AAA.rte");
							--print(item);
							item.PresetName = self.spellname .. " Rollerbomb";
							item.Sharpness = self.Team * 100 + self.spell;
							self:AddInventoryItem(item);
						end
					elseif self.core == 5 then
						--[[
						local item = CreateTDExplosive("Splash Potion", "AAA.rte");
						--print(item);
						item.PresetName = self.spellname .. " Grenade";
						item.Sharpness = self.Team * 100 + self.spell;
						--print(item.Sharpness);
						self:AddInventoryItem(item);
						PlaySound("Cage Down Sound Emitter",self.Pos);
						--ToHDFirearm(self.EquippedItem):GibThis();
						local name = self.EquippedItem.PresetName;
						self:EquipNamedDevice(item.PresetName,true);
						self:RemoveInventoryItem(name);
						--self:EquipThrowable(true);
						local explosion = CreateMOSRotating("Particle Summon Explosion", "AAA.rte");
						explosion.Pos = target + Vector(0,-6);
						explosion.Vel = Vector(0,0);
						MovableMan:AddParticle(explosion);
						explosion:GibThis();
						]]
						local PlayedSound = CreateAEmitter("Scream Sound Emitter");
						PlayedSound.Pos = self.Pos;
						MovableMan:AddParticle(PlayedSound);
						if self.element == 6 then
							--local PlayedSound = CreateAEmitter("Dupe Sound Emitter");
							--PlayedSound.Pos = self.Pos;
							--MovableMan:AddParticle(PlayedSound);
							local summon = CreateAHuman("Zombie Bomber", "AAA.rte");
							summon.Team = self.Team;
							summon.Pos = self.Pos;
							summon.Vel = Vector(0,0);
							if math.random(1,2) == 2 then
								summon.HFlipped = true;
							end
							--summon.AIMode = Actor.AIMODE_SENTRY;
							MovableMan:AddActor(summon);
							summon:FlashWhite(200);
							ToActor(summon):SetNumberValue("Spell",self.spell);
						end
						local summon = CreateAHuman("Zombie Bomber", "AAA.rte");
						summon.Team = self.Team;
						summon.Pos = self.Pos;
						summon.Vel = Vector(0,0);
						if math.random(1,2) == 2 then
							summon.HFlipped = true;
						end
						--summon.AIMode = Actor.AIMODE_SENTRY;
						MovableMan:AddActor(summon);
						summon:FlashWhite(200);
						ToActor(summon):SetNumberValue("Spell",self.spell);
						ActivityMan:GetActivity():SwitchToActor(ToActor(summon),ToActor(self):GetController().Player,self.Team);
						ToHDFirearm(self.EquippedItem):GibThis();
						self.core = -1;
						--explosion:GibThis();
						--return nil
					end
					if ToActor(self):GetNumberValue("Mana") < self.spellcost and self:IsPlayerControlled() then
						local PlayedSound = CreateAEmitter("No Mana Sound Emitter");
						PlayedSound.Pos = self.Pos;
						MovableMan:AddParticle(PlayedSound);
					end
				end
				if self.core < 0 or ToHDFirearm(self.EquippedItem):IsActivated() == false then
					self.chargeTimer:Reset();
					self.charged = false;
				end
			end
		end
	end
	if self:GetController():IsState(Controller.PRIMARY_ACTION) == false then
		self.selected = false;
	end

end