dofile("Base.rte/Constants.lua")
dofile("Base.rte/Actors/AI/HumanAI.lua")
dofile("AAA.rte/MAGen.lua")

function Create(self)

	self.AI = NativeHumanAI:Create(self)

	self.element = 0;
	self.twiceChance = 0.0;
	self.freeChance = 0.0;
	self.dupeChance = 1.0;
	if ToActor(self):NumberValueExists("Summon") == false then
		ToActor(self):SetNumberValue("Summon", -10);
	end
	if ToActor(self):NumberValueExists("Max Mana") == false then
		ToActor(self):SetNumberValue("Max Mana", 800);
	end
	if ToActor(self):NumberValueExists("Mana") == false then
		ToActor(self):SetNumberValue("Mana", 800);
	end
	if ToActor(self):NumberValueExists("Mana Regen") == false then
		ToActor(self):SetNumberValue("Mana Regen", 10);
	end
	if ToActor(self):NumberValueExists("Spell Speed") == false then
		ToActor(self):SetNumberValue("Spell Speed", 1);
	end
	if ToActor(self):NumberValueExists("Spell Max") == false then
		ToActor(self):SetNumberValue("Spell Max", 10);
	end
	if ToActor(self):NumberValueExists("Efficiency") == false then
		ToActor(self):SetNumberValue("Efficiency", 1.0);
	end
	
	self.spellchoice = 1; --selected spell position in spelllist, only use in selection mode
	self.spellnumber = 6; --size of spelltable
	self.spelltable = {}; --start from 0
	
	self.spelltable[1] = 8;  --start w arrow
	self.spelltable[2] = 6;  --start w shell
	self.spelltable[3] = 44;  --start w frost star
	self.spelltable[4] = 27;  --start w acid rain
	self.spelltable[5] = 37;  --start w meteor
	self.spelltable[6] = 18;  --start w mjornir
	
	
	
	MageInit(self);

end

function UpdateAI(self)
   self.AI:Update(self)
end

function Update(self)
	MageStep(self);
end

function Destroy(self)

end