dofile("Base.rte/Constants.lua")
dofile("Base.rte/Actors/AI/HumanAI.lua")
dofile("AAA.rte/MAGen.lua")

function Create(self)

	self.AI = NativeHumanAI:Create(self)

	self.element = 3;
	self.twiceChance = 0.4;
	self.freeChance = 0.0;
	self.dupeChance = 0.2;
	if ToActor(self):NumberValueExists("Summon") == false then
		ToActor(self):SetNumberValue("Summon", -1);
	end
	if ToActor(self):NumberValueExists("Element") == false then
		ToActor(self):SetNumberValue("Element", 3);
	end
	if ToActor(self):NumberValueExists("Max Mana") == false then
		ToActor(self):SetNumberValue("Max Mana", 200);
	end
	if ToActor(self):NumberValueExists("Mana") == false then
		ToActor(self):SetNumberValue("Mana", 200);
	end
	if ToActor(self):NumberValueExists("Mana Regen") == false then
		ToActor(self):SetNumberValue("Mana Regen", 9);
	end
	if ToActor(self):NumberValueExists("Spell Speed") == false then
		ToActor(self):SetNumberValue("Spell Speed", 0.7);
	end
	if ToActor(self):NumberValueExists("Spell Max") == false then
		ToActor(self):SetNumberValue("Spell Max", 5);
	end
	if ToActor(self):NumberValueExists("Efficiency") == false then
		ToActor(self):SetNumberValue("Efficiency", 1.0);
	end
	
	self.spellchoice = 1; --selected spell position in spelllist, only use in selection mode
	self.spellnumber = 1; --size of spelltable
	self.spelltable = {}; --start from 0
	
	self.spelltable[1] = 30;  --start w firebolt
	
	MageInit(self);

end

function UpdateAI(self)
   self.AI:Update(self)
end

function Update(self)
	MageStep(self);
end

function Destroy(self)
	if self.Sharpness ~= 4 then
		local explosion = CreateMOSRotating("Particle Flare Explosion", "AAA.rte");
		explosion.Pos = self.Pos;
		explosion.Vel = Vector(0,0);
		MovableMan:AddParticle(explosion);
		explosion:GibThis();
		local explosion = CreateMOSRotating("Particle Large Burn Explosion", "AAA.rte");
		explosion.Pos = self.Pos;
		explosion.Vel = Vector(0,0);
		MovableMan:AddParticle(explosion);
		explosion:GibThis();
	end
end