function Create(self)

	self.delayTimer = Timer();
	--self.overallTimer = Timer();
	--self.scanTimer = Timer();
	self.actionPhase = 0;
	--self.blink = false;
	self.fireOn = false;

end

function Update(self)
--[[
	if self.ID ~= self.RootID then
		if self.scanTimer:IsPastSimMS(500) then
			self.scanTimer:Reset();
			if coalitionMineTable ~= nil then
				for i = 1, #coalitionMineTable do
					if MovableMan:IsParticle(coalitionMineTable[i]) and SceneMan:ShortestDistance(self.Pos,coalitionMineTable[i].Pos,SceneMan.SceneWrapsX).Magnitude < 100 then
						local detectPar = CreateMOPixel("Disarmer Detection Particle");
						detectPar.Pos = coalitionMineTable[i].Pos;
						MovableMan:AddParticle(detectPar);
					end
				end
			end

			if coalitionC4TableA ~= nil and coalitionC4TableB ~= nil then
				for i = 1, #coalitionC4TableA do
					if MovableMan:IsParticle(coalitionC4TableA[i]) and SceneMan:ShortestDistance(self.Pos,coalitionC4TableA[i].Pos,SceneMan.SceneWrapsX).Magnitude < 100 then
						local detectPar = CreateMOPixel("Disarmer Detection Particle");
						detectPar.Pos = coalitionC4TableA[i].Pos;
						MovableMan:AddParticle(detectPar);
					end
				end
			end
		end
	end
]]
	if self:IsActivated() then

		if self.fireOn == false then
			self.Magazine.RoundCount = 4000-self.delayTimer.ElapsedSimTimeMS;
			if self.delayTimer:IsPastSimMS(4000) then
				self.delayTimer:Reset();
				self.actionPhase = self.actionPhase + 1;
				--self.blink = false;
			end
			if self.actionPhase == 1 then
			--[[
				if coalitionMineTable ~= nil then
					for i = 1, #coalitionMineTable do
						if MovableMan:IsParticle(coalitionMineTable[i]) and SceneMan:ShortestDistance(self.Pos,coalitionMineTable[i].Pos,SceneMan.SceneWrapsX).Magnitude < 100 then
							local storePos = coalitionMineTable[i].Pos;
							coalitionMineTable[i].Sharpness = 1;
						--	coalitionMineTable[i].ToDelete = true;
							local mine = CreateTDExplosive("Anti Personnel Mine");
							mine.Pos = storePos;
							MovableMan:AddParticle(mine);
						end
					end
				end

				if coalitionC4TableA ~= nil and coalitionC4TableB ~= nil then
					for i = 1, #coalitionC4TableA do
						if MovableMan:IsParticle(coalitionC4TableA[i]) and SceneMan:ShortestDistance(self.Pos,coalitionC4TableA[i].Pos,SceneMan.SceneWrapsX).Magnitude < 100 then
							local storePos = coalitionC4TableA[i].Pos;
							coalitionC4TableA[i].Sharpness = 1;
						--	coalitionC4TableA[i].ToDelete = true;
							local c4 = CreateTDExplosive("Remote Explosive");
							c4.Pos = storePos;
							MovableMan:AddParticle(c4);
						end
					end
				end

				local soundfx = CreateAEmitter("Disarmer Sound Disarm");
				soundfx.Pos = self.Pos;
				MovableMan:AddParticle(soundfx);
				self.fireOn = true;
				]]
				if self.ID ~= self.RootID then
					local actor = MovableMan:GetMOFromID(self.RootID);
					if MovableMan:IsActor(actor) then
						if ToActor(actor):NumberValueExists("Mana") then
							--ToActor(actor).Health = ToActor(actor).Health - 25;
							ToActor(actor):SetNumberValue("Mana", 0);
							if ToActor(actor):GetNumberValue("Max Mana") < 800 then
								ToActor(actor):SetNumberValue("Max Mana", ToActor(actor):GetNumberValue("Max Mana") + 40);
							end
							if ToActor(actor):GetNumberValue("Max Regen") < 20 then
								ToActor(actor):SetNumberValue("Mana Regen", ToActor(actor):GetNumberValue("Mana Regen") + 2);
							end
							if ToActor(actor):GetNumberValue("Spell Speed") > 0.5 then
								ToActor(actor):SetNumberValue("Spell Speed", ToActor(actor):GetNumberValue("Spell Speed") - 0.1);
							end
							if ToActor(actor):GetNumberValue("Spell Max") < 10 then
								ToActor(actor):SetNumberValue("Spell Max", ToActor(actor):GetNumberValue("Spell Max") + 1);
							end
							local explosion = CreateMOSRotating("Particle Summon Explosion", "AAA.rte");
							explosion.Pos = self.Pos + Vector(0,-6);
							explosion.Vel = Vector(0,0);
							MovableMan:AddParticle(explosion);
							explosion:GibThis();
							local summon = CreateAHuman("Raised Zombie", "AAA.rte");
							summon.Team = -1;
							summon.Pos = self.Pos;
							summon.Vel = Vector(0,0);
							summon.AIMode = Actor.AIMODE_SENTRY;
							MovableMan:AddParticle(summon);
							summon:FlashWhite(200);
							local loss = false;
							while loss == false do
								local number = math.random(1,5);
								if number == 1 and ToAHuman(actor).Head ~= nil then
									ToAHuman(actor).Head:Detach();
									loss = true;
								end
								if number == 2 and ToAHuman(actor).FGArm ~= nil then
									ToAHuman(actor).FGArm:Detach();
									loss = true;
								end
								if number == 3 and ToAHuman(actor).BGArm ~= nil then
									ToAHuman(actor).BGArm:Detach();
									loss = true;
								end
								if number == 4 and ToAHuman(actor).FGLeg ~= nil then
									ToAHuman(actor).FGLeg:Detach();
									loss = true;
								end
								if number == 5 and ToAHuman(actor).BGLeg ~= nil then
									ToAHuman(actor).BGLeg:Detach();
									loss = true;
								end
							end
--[[
							|    | ,
							
							| |	 | _
]]
						end
					end
				end
				
				--self.delayTimer:Reset();
				--self.overallTimer:Reset();
				--self.Magazine.RoundCount = 4000;
				self.fireOn = true;
				--self.actionPhase = 0;
				
			end
		end
	else
		self.delayTimer:Reset();
		--self.overallTimer:Reset();
		self.Magazine.RoundCount = 4000;
		self.fireOn = false;
		self.actionPhase = 0;
	end

end