--package.loaded.Constants = nil; require("Constants")
dofile("AAA.rte/SpellFunctions.lua")

function Create(self)

	--self.Team = self.Sharpness;
	--self.Sharpness = 0;
	self.delayTimer = Timer();
	self.manacost = 0;
	self.manaregen = self.Sharpness;
	self.Sharpness = 0;

	self.spellnumber = 0; --size of spelltable
	self.spelltable = {}; --start from 1
	self.spellx = {}; --start from 1
	self.spelly = {}; --start from 1
	self.spelldir = {}; --start from 1
	
	for parti in MovableMan.Particles do
		if parti.Team == self.Team then
			--if string.find(parti.PresetName, "Mechanism") ~= nil then
			if parti.PresetName == "Spell Mechanism" then
				if SceneMan:ShortestDistance(parti.Pos, self.Pos, true).Magnitude <= 1000 then
					self.spellnumber = self.spellnumber + 1;
					self.spelltable[self.spellnumber] = parti.Sharpness;
					self.spellx[self.spellnumber] = parti.Pos.X;
					self.spelly[self.spellnumber] = parti.Pos.Y;
					self.spelldir[self.spellnumber] = parti.RotAngle;
					self.spellname, self.spellcost, self.spellcast, self.spellrange, self.spellmode = SpellGet(parti.Sharpness);
					self.manacost = self.manacost + self.spellcost;
					parti.ToDelete = true;
				end
			end
		end
	end
	
	self.delay = math.max(500,1000 * math.ceil(self.manacost / self.manaregen));
	
end

function Update(self)

	if self.delayTimer:IsPastSimMS(self.delay) then
		if self.spellnumber > 0 then
			for i = 1, self.spellnumber do
				local position = Vector(self.spellx[i],self.spelly[i]);
				SpellCast(self.spelltable[i], nil, position, position, self.spelldir[i], -1);
			end
		end
		self.delayTimer:Reset();
	end

end

function Destroy(self)

end