function Create(self)
	self.stepx = self.Vel.X;
	self.stepy = self.Vel.Y;
	--self.Vel.X = 0;
	--self.Vel.Y = 0;
	self.Timer = 0;
	self.number = 0;
end

function Update(self)

	--self.Pos.X = self.Pos.X + self.stepx;
	--self.Pos.Y = self.Pos.Y + self.stepy;
	self.Timer = self.Timer + 1;
	--self.RotAngle = math.sin(self.Timer / 4);
	self.RotAngle = 0;
	--print(self.RotAngle)
	self.number = self.number + math.random()*0.05 - 0.025;
	self.number = self.number * 0.8;
	--self.Vel = Vector(self.stepx,self.stepy):RadRotate(self.RotAngle);
	self.Vel = Vector(self.Vel.X,self.Vel.Y):RadRotate(self.RotAngle+self.number);

	if self.Timer > 30 then
		local dist, part, chosenpart
		local curdist = 50

		--Cycle through all MOs and see which is the closest.
		for i = 1, MovableMan:GetMOIDCount() - 1 do
			part = MovableMan:GetMOFromID(i)
			if part.ClassName ~= "MOSParticle" and part.ClassName ~= "MOPixel" and part.ClassName ~= "HDFirearm" and part.ClassName ~= "HeldDevice" then
				part = ToMovableObject(part)
				dist = SceneMan:ShortestDistance(self.Pos, part.Pos, false).Magnitude
				if dist < curdist then
					curdist = dist
					chosenpart = part
				end
			end
		end

		--If a part was found in the range, find its parent actor and burn it.
		if chosenpart then
			local MO = MovableMan:GetMOFromID(chosenpart.RootID)
			if MovableMan:IsActor(MO) then
				MO = ToActor(MO)
				MO.Health = MO.Health - 100 / MO.Mass	-- reduce damage to heavy actors
			end
		end
	end
	if self.Vel.Magnitude < 10 then
		self:GibThis();
	end
end
